______________________________________________________________________________

YTD v1.19                                                    (c) 2009-13 Pepak
http://www.pepak.net/ytd                                  http://www.pepak.net
______________________________________________________________________________

CHANGELOG
---------

  v1.19:

    * Aktualizován podpisový certifikát.

    * Noví poskytovatelé:
      - Own3D.tv
      - Polar.cz
      - SchoolOfCare.ru

    * CeskaTelevize.cz: Doplněna podpora pro stahování titulků. Pokud by kvůli
      tomu náhodou některé video nešlo vůbec stáhnout, vypněte stahování
      titulků v konfiguraci ČT a pak mi dejte vědět.

    * Hasici150.tv: Doplněna podpora pro RTMP videa. Původní Microsoftí videa
      by měla stále fungovat, bohužel mám jenom videa, která už nefungují ani
      na webu (nicméně všechny potřebné parametry pro ně se najdou, takže
      pokud existuje i nějaké funkční video, tak by mělo jít stáhnout).

    * iPrima.cz: Když už dělám verzi, tak jsem zaktualizoval i Primu, ale
      nejspíš dlouho nevydrží...

    * MamaOzenMa.joj.sk: Měly by fungovat i ostatní pořady Joj.sk, ale nemám
      je vyzkoušené.

    * Nova.cz: Kompletně překopáno. Nyní už fungují jak Flash tak Silverlight
      videa. Lví podíl na této funkci má Balutbj, který k tomu dodal strašnou
      spoustu informací včetně funkčního PHP skriptu, vůči kterému jsem mohl
      ověřovat.

    * Další aktualizovaní poskytovatelé:
      - B-TV.cz
      - Facebook.com
      - Hrej.cz
      - PornHub.com
      - Tube8.com
      - Tyzden.sk



  v1.18:

    * Noví poskytovatelé:
      - PlayZone.cz
      - Reflex.cz

    * Aktualizovaní poskytovatelé:
      - iPrima.cz
      - Rutube.ru
      - SoundCloud.com

    * Nova.cz: Minulá aktualizace sice zprovoznila Silverlight videa, ale zase
      znefunkčnila Flash videa. Teď jsem udělal další zásah, kterým jsem 
      znefunkčnil Silverlight a zprovoznil Flash. Problém je v tom, že nemám na 
      čem to vyzkoušet - vždycky mám k dispozici buď funkční Silverlight video 
      nebo funkční Flash video, ale skoro nikdy ne obojí současně. Teď třeba 
      mám funkční Flash video, ale video, na kterém jsem chtěl testovat 
      Silverlight, nelze použít protože je jen pro předplatitele. Bylo by 
      hezké, kdyby mi někdo mohl sehnat obě videa, pak bych je rozběhal, aby 
      fungovala obě najednou. V mezičase doporučuji v případě neúspěchu u Novy 
      zkusit o kousek starší verzi YTD, jestli to v ní funguje...

    * Zkouknito.cz: Aktualizováno.
      Pozor, stahování nemusí fungovat úplně stoprocentně - server má
      tendenci čas od času vyhodit hlášku, že "z důvodu překročení kapacity
      je video dočasně nedostupné". Ale to je problém v serveru, ne v YTD.

    * RTMP a RTSP protokoly byly doplněny o smazání prázdného souboru, který
      se mohl vytvořit v rámci nezdařeného downloadu. Toto chování bylo už
      dříve implementováno pro HTTP a slouží k tomu, aby po sobě program 
      nenechával soubory o nulové délce.

    * Opravena čeština v konzolové verzi zkompilované v Unicode.



  v1.17:

    * Noví poskytovatelé:
      - Vii.sk

    * Česká televize.cz
      - Opravena příležitostná chyba errorSOAP.
      - Podpora pro stahování jen častí pořadů v dohledné době nebude,
          přestože k nim existují speciální URL.

    * MojeVideo.sk
      - Aktualizován přehrávač. Stále vyžaduje znalost tokenu.

    * Nova.cz (Voyo.Nova.cz)
      - Podpora pro Silverlightovou verzi.
      - Nejsem si jistý, do jaké míry to je stoprocentní: nepřišel jsem na to,
        jak se rozhoduje o výběru CDN.

    * VideaCesky.cz
      - Podpora pro další způsob embedování videa.

    * V titulku hlavního okna se nyní zobrazuje informace o tom, jestli je YTD
      v Unicode nebo v ANSI verzi.



  v1.16:

    * Noví poskytovatelé:
      - Azet.sk
      - EuroSeptik.cz
        - Podporováno je i stahování titulků. Ve výchozím stavu se stahují
          anglické titulky, v české verzi české titulky. V konfiguraci 
          stahovačů lze nastavit i jiné titulky, například "Přepis, angličtina"
          nebo "Přepis, čeština" (název vychází z označení titulků na stránce
          poskytovatele; stačí i část textu, nemusí být celý, tzn. funguje
          i "čeština").
      - Matrix-2001.cz
      - MetroProjekt.cz
      - T-Music.cz (díky Balutbj)
      - Vikend.Nova.cz (a zřejmě i ostatní podobné podweby Novy)

    * Aktualizovaní poskytovatelé:
      - FunnyOrDie.com
      - YouTube.com

    * Zrušena podpora pro server Huste.tv (také Huste.sk), protože vyžaduje
      přihlášení a já nemám testovací účet, se kterým bych mohl experimentovat.
      Kdybych ho měl, zprovoznění by pravděpodobně bylo dost rychlé.

    * Upraveno mazání prázdných souborů, pokud download skončil chybou -
      teď se mazaly, jen pokud download skončil "úspěšně" (v uvozovkách,
      protože prázdný soubor za úspěch nepovažuji).

    * Upraveno generování názvu souboru pro RTMP a MS downloadery v unicode 
      verzi YTD. To řeší neschopnost unicode verze stahovat některá videa
      z České televize, která ale šla v pořádku stáhnout ansi verzí.

    * Zaktualizován RTMPDUMP na verzi z 22.9.2012. Hlavní novinkou nového
      RTMPDUMPu je tzv. realtime režim, ve kterém se stahovač nesnaží urychlit
      download pomocí časté pauzy a nového startu - některé servery totiž na
      pauzu reagují tak, že skočí ve videu o kousek zpátky a stažené video je
      pak téměř nepoužitelné. Režim Realtime je v YTD standardně zapnut u
      všech serverů založených na RTMP, můžete ho vypnout pro každý server
      zvlášť v konfiguraci.

    * Dokumentace zkonvertována do kódování Unicode.



  v1.15:

    * Výchozí verze je nyní Unicode. Výhodou je, že podporuje všechny světové
      jazyky, tzn. není problém stahovat z ruských nebo japonských serverů
      s původními názvy souborů. Nevýhodou je, že Unicode verze nefunguje s
      Windows 98 (ani ne tak kvůli Unicode jako takovému, jako kvůli tomu, že
      Delphi 2009 prostě už podporu pro Windows řady 9x nemají) a je o něco
      delší. Pokud chcete stále používat ANSI verzi, můžete si ji stáhnout z
      mých stránek a ta se nadále bude aktualizovat opět na ANSI verze. Ale
      pokud nepoužíváte Windows 98, tak podle mě není důvod se k ANSI verzi
      vracet.

    * Nový streamovací protokol: Adobe HDS. Používá ho například RuTube.ru
      a vyzvačuje se tím, že se stream skládá ze spousty samostatně 
      stahovaných souborů, které je následně třeba zkombinovat. Zatím je 
      implementována jen značně zjednodušená verze. Pokud se osvědčí, může
      být případně doplněna o zatím neřešené funkce (podpora packetů mimo
      pořadí, někdy možná i navazování spadlého spojení nebo download víc
      fragmentů současně).

      Tímto bych chtěl poděkovat uživateli Litew za jeho neocenitelnou pomoc
      při betatestování protokolu.

    * Noví poskytovatelé:
      - eKucharka.net
      - TopRecepty.cz

    * Aktualizovaní poskytovatelé:
      - Hasici150.tv
      - Rutube.ru (podpora pro HDS streamy)



  v1.14:

    * Noví poskytovatelé:
      - Ocko.tv
      - TeenMpegs.com (porno)

    * Aktualizovaní poskytovatelé:
      - DailyMotion.com
      - RuTube.ru (víc podporovaných videí, ale zatím ne HDS)
      - YouTube.com (unicode verze YTD špatně dekódovala jméno videa)

    * Opravena chyba, kvůli které se například z České televize stahoval jeden
      soubor stále dokola.



  v1.13:

    * Nově je ke stažení experimentální verze s podporou Unicode. Bude se 
      hodit zejména u webů v exotických jazycích, například v ruštině nebo 
      japonštině. Uvítal bych, kdybyste si ji mohli stáhnout a dát mi vědět, 
      jestli s ní jsou nějaké problémy, protože bych ji rád časem nechal jako 
      hlavní. Zatím nechávám jako výchozí ANSI verzi, protože ta funguje i s 
      Windows 98, Unicode bude chtít aspoň Windows 2000.

    * Noví poskytovatelé:
      - Kiwi.kz
      - Myvi.ru
      - Nova.cz (pouze free videa; vyžadována je znalost tokenu)
      - ProstoPleer.com
      - RuTube.ru
      - Sibnet.ru

    * Aktualizovaní poskytovatelé:
      - CestyKSobe.cz
      - XHamster.com

    * Doplněn ruský překlad z projektu rStread 
      (https://bitbucket.org/litew/rstread).

    * Doplněno časové omezení na videa v jednom playlistu, po jehož uplynutí
      se vynutí nové stáhnutí a zpracování informační stránky. V důsledku toho
      už by vícedílná videa např. na stránkách České televize (http://www.ceskatelevize.cz/porady/10120914283-buly-hokej-zive/211471290130045-hc-vitkovice-steel-hc-eaton-pardubice/
      a podobné) měla jít stáhnout kompletní, ne jen první díl nebo dva, podle
      toho, jak rychle se podařilo stáhnout předchozí díly. Pevně doufám, že
      to nerozhodilo dosud fungující vícedílná videa.

    * Ve VCL verzi chyběly v menu funkce "přehrát" a "otevřít složku", i když
      naprogramované byly. (Toto se ovšem týká jen toho, kdo si YTD kompiloval
      ze zdrojových kódů, ve kterých si vynutil použití VCL).

    * V Unicode verzi byl zaveden speciální režim pro stahování videí přes
      RTMP a RTSP, při kterém se v případě nutnosti použije dočasné jméno
      souboru a to se následně přejmenuje na finální. Typické použití je
      u RuTube.ru, kde se název v azbuce přeloží na samé otazníky a to není
      platné jméno souboru. Obdobné to bude v budoucnu s čínskými, japonskými
      apod. servery.

    * Při stahování souborů delších než 2 GB se správně zobrazuje průběh
      downloadu.

    * Funkce pro nahlášení chyby funguje pouze pro videa, u kterých se 
      nepodařilo zahájit stahování. Jakmile je totiž stahování jednou zahájeno,
      tak už YTD jeho průběh nemůže ovlivnit - úspěšné dokončení je čistě věcí
      vašeho internetového připojení a stability serveru.

    * Ještě jednou přepracován kompilační skript, aby se dal snadno použít
      na libovolnou verzi Delphi, včetně případných budoucích. Ověřena možnost
      zkompilovat YTD na Delphi 5, 7, 2007, 2009, XE2 a na FreePascalu 2.6.0.
      64bitová verze jde zkompilovat pomocí Delphi XE2, ale pak nejde spustit
      kvůli některým chybějícím exportům v DLL, ke kterým nemohu dohledat, kde
      se v YTD berou.



  v1.12:

    * Noví poskytovatelé:
      - VideoPortal.sk
      - Viki.com, VikiAssets.com

    * Aktualizovaní poskytovatelé:
      - CD.cz
      - eHow.com
      - EuroGamer.cz
      - Metropol.cz
      - Metoo.sk (podpora pro RTMP)
      - RozzlobeniMuzi.com (názvy videí)
      - Sport.cz
      - Video.Google.com (embedded verze)
      - VKontakte.ru (konečně se stahuje v nejvyšší kvalitě)
      - Overstream.net (prodloužen timeout; OverStream je strašně pomalý)

    * Grafická verze YTD se nyní standardně spouští jen v jedné instanci;
      pokud už YTD běží z dřívějška, tak se jen aktivuje původní verze a nová
      skončí.

    * Podpora pro command-line parametry i v GUI verzi. Musí vždy být uveden
      parametr --gui (protože normálně je přítomnost argumentů signálem pro
      spuštění textové verze) a navíc mohou být uvedeny argumenty:

      -new .... Spustí novou instanci YTD.
      <url> ... Zařadí do stahování URL <url>. Může být uvedeno i víckrát.

    * Ikonky vytvářené instalátorem nebo v konfiguraci nyní obsahují parametr
      --gui, takže se při jejich použití YTD vždy spustí v grafickém režimu.

    * Nový parametr -nd pro verzi pro příkazovou řádku zajistí, že YTD provede 
      všechny své běžné operace, ale přeskočí vlastní download. Hodí se to 
      zejména pro ladící účely nebo pro případ, že chcete použít vlastní 
      downloadovací program s vlastními doplňujícími parametry.

    * Opravena chyba, při které se po dokončení downloadu neodstranila z názvu
      souboru přípona .part (pokud bylo v nastavení zapnuto používání této
      přípony).

    * Opravena chyba, kvůli které se po dokončeném downloadu video zase smazalo
      s hlášením, že nebyla stažena žádná data, pokud bylo delší než 2 GB.
      Pozn.: Stále se v průběhu stahování takových videí nezobrazuje průběh,
      to je na složitější opravu v Synapsi.

    * Opravena chyba při startu programu, pokud byl poškozený konfigurační
      soubor - YTD sice nahlásil, že vytvoří nový, ale ve skutečnosti to
      neudělal.

    * Při výpisech do konzole se používá OEM kódová stránka (v českých Windows
      852), aby měly texty správnou češtinu.

    * Upraven kompilační skript tak, aby byl víceméně společný pro všechny
      mé programy.



  v1.11:

    * Nový poskytovatel: Mixer.cz.

    * Opravena chyba z 1.09, kvůli které byl pro ČT vyžadován token i tam, kde
      ve skutečnosti není potřeba.



  v1.10:

    * Opravena chyba, kvůli které přestaly fungovat skoro všechny RTMP streamy.



  v1.09:

    * Noví poskytovatelé: 
      - Laola1.tv (asi jen některá videa)
      - NebickoVPapulke.sk
      - Ulož.to (pouze Ulož.to LIVE)
      - Zvrácený.cz (porno)

    * Aktualizovaní poskytovatelé:
      - Rajče.iDnes.cz
      - MojeVideo.sk (nově vyžaduje token!)

    * YouTube.com: Změnil jsem logiku dekódování objektu FmtUrlMap, takže by
      nyní měla fungovat i videa s neobvyklým pořadím parametrů. Teoreticky
      to mohlo i něco rozhodit, takže když narazíte na video, které ve verzi
      1.08 funguje a ve verzi 1.09 už ne, dejte vědět.

    * Knihovna Synapse aktualizována na verzi 40. Pokud narazíte na příklad
      něčeho, co ve verzi 1.09 nefunguje a ve verzi 1.08 ano, dejte mi prosím
      vědět. Díky.

    * YTD lze nyní zkompilovat pomocí Delphi XE2 (32bitový režim). Ověřena
      funkčnost kompilačních skriptů pro Delphi 5, 7, 2007, 2009, XE2 a pro
      FreePascal.



  v1.08:

    * Jsem zpět a v plné síle! Děkuji Balutbj, že mě v mezidobí zastoupil s
      Českou televizí a obecně za chvályhodnou snahu o dešifrování různých
      serverů (které budu postupně implementovat).

    * Aktualizovaní poskytovatelé:
      - B-TV.cz
      - Blip.tv
      - Česká televize
      - iPrima.cz
      - Joj.sk
      - Muvi.cz
      - RozzlobeniMuzi.com
      - Super.cz
      - Vimeo.com

    * Barrandov.tv: Pokud je dostupná, stahuje se HD kvalita. Je to ale dost
      ošklivý hack, takže to nemusí fungovat; v nastavení Barrandova je na to
      checkbox.

    * CeskaTelevize.cz:
      1. ČT opět funguje.
      2. V konfiguraci je nové nastavení pro maximální bitrate, který YTD bude
         stahovat (pokud bude mít na výběr - pokud existuje jen vyšší bitrate,
         použije se ten). ČT momentálně používá bitrate 2000, 1000, 500.

    * Opravena nežádoucí interakce mezi sledováním schránky (clipboardu)
      a funkcí pro zkopírování vybraných URL do schránky.

    * YTD lze nyní zkompilovat i pomocí Delphi 7.



  v1.07:

    * Vlastně jsem chtěl verzi dělat, až do ní budu mít víc novinek (a zejména
      až budu mít čas podívat se na novou Novu, ale článek publikovaný na
      iDnes mě donutil...).

    * iPrima.cz: Uvolněn formát URL (Prima fungovala i v minulé verzi, ale
      musela se ručně upravit adresa).

    * Nova.cz: Vyřazena z programu. Pravděpodobně navždy, protože free obsah
      byl zrušen a k placenému nemám přístup.



  v1.06:

    * iPrima.cz: Podpora pro Prima Play.

    * VKontakte.ru: Podpora pro videa, která nemají kvalitu 720. Lepší práce
      s názvy souborů.

    * YouTube.com: Podpora pro playlisty ve tvaru "playlist?list=...".

    * Několik drobných úprav v získávání názvů souborů.



  v1.05:

    * Noví poskytovatelé:
      - CriticalPast.com
      - Smotri.com

    * Aktualizovaní poskytovatelé:
      - EmpFlix.com
      - iPrima.cz
      - MojeVideo.sk (stará videa možná nebudou chodit)
      - TN.Nova.cz
      - UStream.tv
      - Vimeo.com (podpora pro HD)
      - YouTube.com (playlisty)

    * AutosalonTV.cz
      Zrušena podpora, protože se nyní používá streamování pomocí ISM, kde
      je video rozděleno na mnoho malých částí a je posíláno po kouskách,
      video zvlášť a zvuk taky zvlášť. Šlo by to stáhnout, ale nebylo by to
      k ničemu.

    * Nova.cz: Pokud je špatné heslo, tak na to program v chybové hlášce 
      upozorní.

    * VKontakte.ru: Podpora pro vk.com/video_ext.php?...

    * Opravena logika pro získávání názvu z vnořených dowloaderů (pozitivně
      to ovlivňuje např. iDnes, ostatním to snad nevadí nebo je to také
      zlepšuje).

    * GUI: Funkce pro otevření složky nyní funguje i na videa, jejichž 
      stahování dosud nezačalo nebo je program ani nezná. V takovém případě
      se otevře výchozí adresář pro stahovaná videa.



  v1.04:

    * Aktualizovaní poskytovatelé:
      - iPrima.cz

    * Aktualizován zdrojový kód, aby se zkompiloval pod Delphi 2009.



  v1.03:

    * Nova.cz: Podpora pro další typy vkládaných videí (např. poker.nova.cz).

    * YouTube.com: Podpora pro videa některých třetích stran, která používají
      speciální zápis přehrávače.

    * Aktualizován jazykový soubor.



  v1.02:

    * Chyba v Markiza.sk způsobovala výjimku na neznámých URL.



  v1.01:

    * Nový poskytovatel: LevelTV.Hrej.cz.
      Poskytovatel teoreticky vyžaduje znalost hesla, které můžete v grafickém
      rozhraní zadat do konfigurace. Prakticky zatím heslo není potřeba, server
      ho nijak nekontroluje.

    * Nový poskytovatel: NHL.com.
      Nejsem si tak docela jistý, co vlastně bylo vyžádáno a co stahuji.

    * Další noví poskytovatelé:
      - 3news.co.nz
      - Ancensored.com
      - Archive.org
      - Casting.xxx (porno)
      - Gavin.xxx (porno)
      - LenkaFilipova.cz
      - Online.Hokej.cz
      - Zapiks.fr
      - ZlutySnih.cz (porno)

    * DailyMotion.com: V plné verzi stahuje i videa označená jako pro dospělé.

    * KeezMovies.com: Podpora pro embedded verzi.

    * MetaCafe.com: Aktualizována podpora streamů přes HTTP. Ještě existují
      streamy běžící na RTMP, ty zatím podporovány nejsou.

    * Další aktualizovaní poskytovatelé:
      - FreeCaster.tv
      - JenProMuze.cz
      - Metropol.cz

    * Do výchozího konfiguračního souboru byla přidána nastavení pro konverzi
      videí pomocí programu FFmpeg (http://ffmpeg.org/) (díky ffmpegmann).
      Do konfigurace je dostanete nejlépe tak, že starou konfiguraci smažete
      a necháte YTD, ať si vytvoří novou.

    * Odstraněna zdvojená přípona souboru u některých poskytovatelů.

    * GUI: V konfiguraci nešlo vypnout konvertování titulků do .srt formátu.



  v1.00:

    * Změna názvu programu: Původní "YouTube Downloader"  se nyní jmenuje
      "YTD".

    * Spousta změn ve zdrojových kódech kvůli změně názvu a změně roku, ale
      nic z toho není změna v prováděném kódu.




  v0.99:

    * Noví poskytovatelé:
      - AcademicEarth.org
      - TV-Vysocina.cz

    * CeskaTelevize.cz: Nové stránky používají secure token, který si někde 
      musíte získat sami, já ho rozšiřovat nemohu.

    * Nova.cz: Opět funkční.

    * Prima-Cool.cz: Opět funkční.

    * Video.Nur.kz: Opravena přípona u souborů.

    * Obecný parser HTML stránek doplněn o podporu <param name="movie">. Tím
      je zajištěna podpora řady dalších webů, které přebírají obsah např.
      z YouTube apod., například Topky.sk, Pluska.sk.

    * Do stahovače protokolů MMS/RTSP byl přidán test, jestli je stažený
      soubor dlouhý aspoň 64 KB. To by mělo vyvolat chybové hlášení v 
      případech, kdy server sám chybu nenahlásí, jen nic nestáhne.

    * RTMPDUMP aktualizován na nejnovější verzi (GIT tag 60218d0af0f4bd683ecdebe49986f188820cf8ce).

    * GUI: V nastavení stahovačů už se pro každého poskytovatele zobrazuje
      maximálně jedna stránka.



  v0.98:

    * Noví poskytovatelé:
      - BMovies.com
      - B-TV.cz
      - CSFD.cz
      - GamePark.cz
      - GameZone.com
      - Games.Tiscali.cz
      - KanalTurk.com.tr
      - Kinobox.cz
      - Metoo.sk
      - Motherless.com (porno)
      - PlayWire.com
      - Rajce.iDnes.cz
      - RawTube.com (porno)
      - ShackNews.com
      - SteamPowered.com
      - TV2Nord.dk
      - Video.Nur.cz
      - World-Club.net
      - Youtu.be
      - YouTube-nocookie.com
      Tím se dostáváme na 250 podporovaných poskytovatelů.

    * CeskaTelevize.cz: ČT24 opět běží.

    * MegaVideo.com: Podpora pro embedované přehrávače.

    * Rozhlas.cz: Opět běží.

    * YouTube.com: Aktualizován seznam formátů, které YouTube používá, takže
      by už se nemělo stávat, že se video stáhne do souboru se špatnou 
      příponou.

    * Lite verze: Do Lite verze se už před mnoha verzemi dostalo několik porno
      poskytovatelů. Nyní byli odstraněni a prověřil jsem, že už tam žádní
      nezbyli.

    * RTMP: Výchozí nastavení pro živé vysílání je "vypnuto" pro všechny
      servery kromě České televize, Novy, Primy a Barrandova, protože jsem
      zjistil, že u mnoha "normálních" serverů toto nastavení překáží ve
      stahování videa. Doporučuji smazat konfigurační soubor a nechat YTD
      vytvořit nový, aby tuto změnu převzal (jinak si ponechá nastavení
      původní).



  v0.97:

    * CeskaTelevize.cz: 
      - Vrací se kód z verze 0.94 - tzn. funguje jen první video na stránce, 
        ale funguje spolehlivě.
      - Některá videa nešla stáhnout, pokud měla v popisku nečekané kombinace
        znaků.

    * Free.Zoznam.sk: Podpora pro videa ve formátu MP4.

    * iPrima.cz: Uvolněn formát adres, takže je rozpoznáváno víc videí.

    * KeezMovies.com: Opět funkční.

    * RedTube.com: Podpora pro HQ i LQ videa.

    * TV7.cz: Opět funkční.

    * TVcom.cz: Uvolněn formát adres, takže je rozpoznáváno víc videí.

    * XHamster.com: Podpora pro HQ i LQ videa (před 0.96 šly jenom LQ, v 0.96
      jenom HQ, teď jde oboje; možná jsou i některé další režimy, pokud ano,
      tak nejdou).

    * CLI: Místo toho, aby se zobrazovalo skutečné URL videa jako dosud, se
      zobrazuje přímo příkaz (WGET, RTMPDUMP, MSDL), který dokáže video
      stáhnout. Hodí se to hlavně pro ladění RTMP stahování.



  v0.96:

    * Noví poskytovatelé:
      - 4TV.cz
      - VideoBB.com

    * CeskaTelevize.cz: 
      - Komponenta nerespektovala nastavení Live Stream, v důsledku toho bylo 
        stahované video trhanější, než je nezbytné.
      - Vyčištěn název videa.
      - Podpora pro stahování víc videí z jedné stránky na ČT24, bohužel zatím
        všechny pod stejným názvem videa (takže nepoužívejte přepisovací režimy
        "přepisovat" nebo "přeskakovat").

    * iPrima.cz: Aktualizováno na současnou podobu stránek.

    * Nova.cz: Aktualizováno na současnou podobu stránek.

    * XHamster.xom: Aktualizováno na současnou podobu stránek.



  v0.95:

    * Noví poskytovatelé:
      - FarmarHladaZenu.sk
      - HejbejSe.tv
      - Metropol.cz
      - Osobnosti.cz

    * Blip.tv: Opět funkční.

    * CeskaTelevize.cz: ČT24 opět funkční.

    * iPrima.cz: Pokud k pořadu existuje stránka http://prima.stream.cz/<id>,
      bude se stahovat v ještě vyšší kvalitě než dosud.

    * Stream.cz: Podpora videí v profilech uživatelů:
      http://www.stream.cz/profil/seznam.cz/safranjan?video_id=604024

    * Všechny downloadery založené na RTMP protokolu mají nyní nastavení,
      jestli se mají stahovat v režimu živého streamu. Živý stream je výrazně
      pomalejší (zhruba v reálném čase), na druhou stranu je výrazně méně
      náchylný na sladění serveru a klienta a z větší části zabraňuje rozpadání
      obrazu či zvuku či přeskakování tam a zpět. Ve výchozím stavu je pro
      všechny downloadery zapnutý, vypnout ho můžete v grafické konfiguraci
      nebo v XML (viz <live_stream> v dokumentaci).



  v0.94:

    * Nova.cz: Aktualizována RTMP verze na aktuální tvar. Nutnou podmínkou
      pro fungování je znalost tajného hesla, které server používá pro
      autentizaci. Obdobně jako u Barrandova se nemohu vyjadřovat k tomu,
      jak toto heslo získat. Pokud se vám ho podaří najít, nezapomeňte ho
      vložit do konfigurace Novy (v grafickém prostředí je na to kolonka,
      umístění v XML souboru je uvedeno v dokumentaci).

    * Experimentálně bylo pro Novu, Primu a Show Jana Kraise zapnuto stahování
      v režimu "Live". Stahování sice poběží mnohem pomaleji (zhruba rychlostí
      přehrávání), ale s trochou štěstí by to mohlo odstranit "přeskakování"
      videa, které se v posledních týdnech projevuje. Prosím, vyzkoušejte to
      a dejte mi vědět, jak to dopadlo - pokud stahování začne fungovat podle
      očekávání, udělám pro všechny servery běžící na RTMP uživatelsky dostupný
      parametr, kterým se bude dát živý stream zapnout nebo vypnout. Díky.

    * Aktualizována knihovna RTMPDUMP_DLL na verzi z 30.9.2011 (GIT hash
      60218d0af0f4bd683ecdebe49986f188820cf8ce).



  v0.93:

    * Noví poskytovatelé:
      - 8teenXXX.com (porno)
      - Huste.sk
      - MamaOzenMa.sk
      - MojePorno.sk (porno)
      - OK-Team.cz
      - PicSpoon.com
      - VeeHD.com
      - Video.Google.com

    * EuroGamer.cz:
      - Podpora pro stahování titulků a konverzi do .srt.

    * iDnes.cz:
      - Nestahovalo se např. http://zpravy.idnes.cz/drabova-radiace-v-podoli-je-zvysena-tisickrat-zdroj-tam-muze-byt-roky-12b-/domaci.aspx?c=A110929_111532_domaci_jj
    
    * iPrima.cz:
      - U videí hostovaných na Stream.cz, která ale nemají na Stream.cz
        vlastní stránku, se stahovala výchozí verze videa, i když byla k
        dispozici kvalitnější.
      - Podpora pro *archívy* Show Jana Krause (založené na RTMP protokolu).
        Nelze vybrat konkrétní díl, stahují se postupně všechny.
      - Pro videa hostovaná na Livebox.cz (včetně Show Jana Krause) čtěte
        stránku podpory.

    * Markiza.sk:
      - Vylepšeno pojmenovávání videí (např. http://video.markiza.sk/archiv-tv-markiza/bez-servitky/68688).
        Svým způsobem jde o zavedení nové chyby, ne o opravu - původní názvy
        byly správné, jak je zná systém Markízy, jenom byly nevhodné pro lidi.

    * GUI: Experimentální oprava na problém, že chyby vzniklé ve stahovacích
      vláknech nebyly přeloženy a zobrazovaly se anglicky.

    * GUI: Opravena chyba EListError při pokusu o otevření adresáře videa,
      pokud nebylo žádné video vybráno.

    * GUI: Opraveno nefunkční přehrávání videa, otevření adresáře a některé
      další funkce, pokud bylo zvoleno stahování do nějakého konkrétního 
      adresáře (ve výchozím nastavení "stahovat do aktuálního pracovního
      adresáře" to fungovalo i dříve).


  
  v0.92:
  
    * Noví poskytovatelé:
      - EuroGamer.cz
      - ILikeBike.cz
      - R1ZAK.cz
        - Pozor, nelze vybrat pořad, stahují se vždy všechny, které na zvolené
          stránce jsou.

    * Poskytovatelé aktualizovaní na současný tvar stránek:
      - CSmaTalent.cz, CSmaTalent.sk
      - Facebook.com
      - iDnes.cz
      - MediaSport.cz
      - Music.Stream.cz
      - TN.Nova.cz

    * Hasici150.tv: Momentálně jsou nefunkční, protože nejsem schopen najít
      jediné video, které by šlo přehrát (i normálním způsobem v prohlížeči,
      ne jen v YTD).

    * iPrima.cz: Podpora pro nová videa. Stará videa na Streamu fungovala 
      i dříve a fungují i teď.

      Zajímavá informace: Show Jana Krause zjevně někdy v uplynulých měsících
      přešla na nového provozovatele, takže lze nyní v YTD stahovat. Buď 
      všechny díly najednou, pokud do YTD vložíte adresu http://www.iprima.cz/showjanakrause
      (buď pomocí funkce "Vložit URL z HTML stránky", nebo při zapnuté volbě
      "Automaticky používat HTML parser" i běžným způsobem.

    * Particka.Markiza.sk: Podpora pro videa tvořená několika částmi.

    * VideaCesky.cz: Podpora pro titulky u http://www.videacesky.cz/reklamy-reklamni-spot-video/super-heineken
      Zlepšena podpora pro videa přímo hostovaná na serveru videacesky.cz.
      Zlepšena podpora pro stránky, na kterých je flashová reklama.

    * U vnořených objektů (např. VideaCesky.cz) se zobrazuje URL skutečného
      obsahu, ne URL vnořeného objektu.

    * Změněno výchozí nastavení pro stahování titulků na "ano", aby bylo v
      souladu s dokumentací i požadovaným chováním.

    * Ke právě stahovaným souborům se volitelně přidává přípona .part. Po
      skončení stahování se soubor přejmenuje na svůj definitivní název (bez
      .part). Standardně je funkce vypnutá, protože má větší nároky na práva
      než standardní chování, můžete ji ale zapnout v Nastavení na stránce 
      Stahování.

    * V Nastavení na stránce Stahování lze dále zapnout možnost, aby se média
      ukládala do podadresářů podle názvu poskytovatele (média z Novy do
      podadresáře Nova.cz, média z Primy do iPrima.cz atd.).

    * Různé úpravy v kódu za účelem lepší udržovatelnosti.



  v0.91:

    * Nový poskytovatel: HudebniVideoKlipy.cz.

    * Poskytovatelé aktualizovaní na současný tvar stránek:
      - CestyKSobe.cz
      - LiveLeak.com
      - Muvi.cz
      - Novinky.cz
      - TnaFlix.com
      - Tube8.com
      - Tyzden.sk

    * Markiza.sk: Podpora pro projekt Partička.Markíza.sk.

    * Stream.cz: Aktualizováno na současný stav. Podpora pro stahování přímo
      z CDN cache.

    * TVNoe.tbsystem.cz: Přidána podpora pro chybně zakódovaná XML.

    * Vimeo.com: Natvrdo vyžadováno HD video.

    * YouTube.com: Podpora pro stahování videí uložených jako RTMP streamy.

      Přepracován způsob hledání nejlepšího video formátu tak, že se video
      ve formátu .webm stáhne i v případě, že je tento formát zakázaný, pokud
      není žádný jiný formát k dispozici.

      Opravena podpora pro uživatelské stránky (např. http://www.youtube.com/user/bemylovepenguin).
      Momentálně si nejsem jistý, jestli se stahují všechna videa nebo jen
      posledních 25 - potřeboval bych vzorovou stránku, která má videí řekněme
      padesát.

    * Odstraněna zavádějící chybová zpráva "Stahování tohoto obsahu není
      podporováno." v situacích, kdy stahování podporováno je, ale z nějakého
      důvodu se ho nepodařilo spustit.

    * Chyby při downloadech RTMP streamů dostaly podrobnější chybová hlášení
      (vypreparovaná z logu RTMPDUMPu).

    * GUI: Pozměněno spouštění grafické verze YTD ve standardním režimu (bez
      parametru --gui): chování z verze 0.87, kdy se spustí nová kopie YTD
      a stará se ukončí*) se nyní provádí jen při spouštění programu z konzole,
      při spuštění z grafických aplikací zůstává spuštěná jen původní instance.
      (Viditelně by to nemělo nic udělat, ale mohlo by to pomoci paranoidním
      bezpečnostním programům).

      *) Tato operace se provádí proto, aby se grafická verze YTD chovala 
         podobně jako normální GUI aplikace a ne jako aplikace konzolová,
         která si konzoli drží až do svého ukončení.

    * GUI: Opraveny nefunkční horké klávesy v podřízených formulářích (např.
      CTRL+V ve formuláři nastavení nenačetlo obsah clipboardu do vybraného
      editačního pole, ale spustilo stahování obsahu clipboardu v hlavním
      formuláři).



  v0.90:

    * YouTube.com: YouTube změnilo přehrávač.



  v0.89:

    * Odstraněno zapomenuté podrobné logování RTMP streamů. Promažte si prosím
      adresář pro dočasné soubory.



  v0.88:

    * Nova.cz: Podpora pro nový experimentální přehrávač na bázi Silverlight.
      Podpora pro původní přehrávač zůstala (snad) zachována, protože různá
      videa používají různé přehrávače.

    * YouTube.com: V nastavení stahovače lze zakázat formát (kontejner) .webm
      (nový výchozí kontejner pro YouTube videa).



  v0.87:

    * Barrandov.tv: Podpora pro nový přehrávací program. Aby to fungovalo,
      musíte si někde zjistit tzv. Secure Token, který Barrandov vyžaduje,
      a zadat ho do konfigurace programu (viz popis konfigurace v dokumentaci
      nebo nové grafické rozhraní ke konfiguraci níže). Neptejte se mě, kde
      a jak Secure Token získat, z právních důvodů nebudu na tyto dotazy
      odpovídat (podle mě by to sice autorskému zákonu neodporovalo, ale nemám
      chuť riskovat případný soudní spor).

      Děkuji Killermanovi za zjištění potřebných poarametrů.

    * Cas.sk: Zprovozněno několik dalších typů vkládaného videa.

    * CeskaTelevize.cz: K názvu souboru je připojena správná přípona.

    * DrsnySvet.cz: Podpora pro videa hostovaná přímo na serveru.

    * iPrima.cz: Opět běží. Nejsem si jistý tím, jestli se stahuje 
      nejkvalitnější dostupná verze - pokud zjistíte, že ne, napište mi prosím,
      jak ji v prohlížeči vyvolat.

    * SportStream.cz: Předěláno na podporu SportStream.Tiscali.cz.

    * Nový distribuční archív: Dosud byl YouTube Downloader instalován v ZIP
      archívu s tím, že si ho uživatel rozbalí sám podle potřeby. To se bohužel
      ukázalo jako neudržitelné vzhledem k množství lidí, kteří rozbalili jen
      samotný spouštěcí soubor (bez podpůrných knihoven) a pak se divili, proč
      jim nefunguje stahování z České televize. Proto přecházím na nový systém,
      kdy se stahuje soubor .exe, který uživateli nabídne instalaci.

      Pro uživatele, kteří neradi aktualizují: Distribuční soubor je obyčejný
      samorozbalovací archív ve formátu 7-zip, který můžete 7-zipem normálně
      rozbalit. Případně můžete spustit instalaci, stejně jenom zkopíruje
      soubory do zvoleného adresáře, volitelně založí zástupce, a spustí YTD.
      Rozhodně neprovádí žádné zápisy mimo zvolený adresář (kromě volitelných
      zástupců na Ploše a ve Start menu, pochopitelně) ani v registrech.

      Distribuční archív umožňuje spustit YTD i bez instalace. Buď stisknutím
      příslušného tlačítka, nebo přímo spuštěním distribučního archívu s
      parametrem --gui, nebo pomocí běžných parametrů (pak se spustí command-
      line verze a provede obvyklé operace).

      Podrobněji viz heslo "Distribuční archív" v dokumentaci.

    * Nový distribuční model také dovoluje automatickou aktualizaci programu.
      V grafickém prostředí byly všechny nabídky na stáhnutí aktuální verze 
      doplněny tak, aby měl uživatel na výběr stáhnutí (jako dosud) i přímou
      aktualizaci. Upozorňuji však, že pro provedení aktualizace se musí YTD
      restartovat a tím se pochopitelně zastaví všechny běžící přenosy.

      Přibyla možnost zaktualizovat program z příkazové řádky (bez zásahu
      uživatele) pomocí parametru -u. Výsledek se vrátí jako errorlevel (viz
      dokumentace). Pozor, vzhledem k mechanismu, kterým to probíhá, by v 
      aktualizační dávce měla po volání "ytd -u" následovat tak půlsekundová
      pauza.

    * GUI: Doplněna podpora pro grafické nastavení jednotlivých stahovačů:
      V nastaveních (F9) je nová záložka "Nastavení stahovačů", ve kterých
      je pro každý stahovač, na kterém se dá něco konfigurovat, samostatný 
      panel s nastaveními. Všechna nastavení šla už dříve zapisovat ručně
      v XML souboru konfigurace, takhle je to ale pro někoho pohodlnější.

      Při startu programu bez command-line parametrů se nespustí přímo YTD,
      ale nová kopie YTD a stará se ukončí. To sice mírně zpomalí start, ale
      zato to uvolní konzoli v případě, že bylo YTD spuštěno z konzolové
      aplikace (CMD, FAR Manager apod.). Předchozí chování (přímé spuštění
      YTD) je zachováno pro CLI verzi programu, spuštění programu z Delphi
      IDE a spuštění programu s parametrem --gui.

      Opravena chyba, kvůli které nešlo vytvářet zástupce na ploše ani ve
      Start menu.

    * Knihovna RTMPDUMP_DLL aktualizována na verzi 2.4 (sestavení ze dne 
      20.7.2011). V této verzi by měl být podporován handshake z Flashe 10,
      tzn. měly by zmizet chyby "HandShake: Type mismatch: client sent 6, 
      server answered 9".

    * Opraveno několik nekompatibilit s Delphi 2009 a FreePascalem.

    * Aktualizován slovenský překlad (V. Kubala).



  v0.86:

    * CeskaTelevize.cz: Z předchozí verze jsem zapomněl odstranit podrobný 
      log soubor (který snadno narůstal do velikosti několikanásobně větší
      než je velikost celého videa). Také nefungovala vícečásťová videa.



  v0.85:

    * CeskaTelevize.cz: Opět funkční.

    * Grafická verze programu si pamatuje svou velikost a umístění a také
      šířku sloupců.



  v0.84:

    * Nový poskytovatel: Agresori.com.

    * Nový poskytovatel: FreeVideo.cz (porno).

    * Nový poskytovatel: G4TV.com.

    * Nový poskytovatel: iViewTube.com.

    * Nový poskytovatel: SoundCloud.com.

    * Nový poskytovatel: Ted.com.

    * Bomba.cz: Zprovozněna videa s URL zakódovanou entitami.

    * Music.Stream.cz: Opět funkční.

    * Shufuni.com: Opět funkční.

    * XTube.com: Opět funkční.



  v0.83:

    * CeskaTelevize.cz: Opravena chyba, na kterou jsem upozorňoval v minulé
      verzi.



  v0.82:

    * Nový poskytovatel: Hell.tv.

    * Nový poskytovatel: JenProMuze.cz (částečně porno).

    * Nový poskytovatel: MachoVideo.com (částečně porno).

    * Nový poskytovatel: Metoo.cz.

    * Nový poskytovatel: Muvi.cz.

    * Nový poskytovatel: NovaMov.com.

    * Nový poskytovatel: PornoZdarma.cz (porno).

    * Nový poskytovatel: TheYNC.com (není porno, ale určitě jen pro dospělé).

    * CT24.cz: Podpora pro http://www.ct24.cz/regionalni/125040-v-kralupech-zrusili-jesle-rodice-s-tim-nesouhlasi/.
      Je pravděpodobné, že tím naopak přestanou fungovat některá dosud funkční 
      videa; když na nějaké narazíte, tak mě prosím upozorněte a stáhněte je
      zatím verzí 0.81. Bohužel to nemohu vyřešit přímo.

    * iDnes.cz: Podpora pro videa přímo ve stránkách, nejen na video.idnes.cz.
      Pozor na správné escapování URL při stahování z příkazového řádku!

    * Joj.sk: Podpora pro pořady s vlastní subdoménou ("Ano, šéfe", "Nové
      bývanie" apod.).

    * PornHub.com: Aktualizováno na současnou podobu stránek.

    * SerialyCZ.cz: Podpora dalšího zápisu vložených videí.



  v0.81:

    * Nový poskytovatel: Bahnorama.com.

    * Nový poskytovatel: Cesnet.cz.

    * Nový poskytovatel: Clevver.com.

    * Nový poskytovatel: Dokumentarni.tv.

    * Nový poskytovatel: FreePornoZdarma.cz (porno).

    * Nový poskytovatel: News.BBC.co.uk.

    * Nový poskytovatel: Serial-Online.cz.

    * Nový poskytovatel: TVLux.sk.

    * CeskaTelevize.cz: Podpora pro Hyde Park a další podobné stránky.

    * CestyKSobe.cz: Opravena chyba "Downloader není připraven".

    * iPrima.cz: Stahuje se nejkvalitnější verze videa i v případě, že server
      preferuje méně kvalitní verzi.
      
    * Joj.sk: Po změně webu opět funguje. Otázka je, jak moc dobře - používám
      pevně stanovený streamovací server, který na pokusných videích fungoval,
      ale nemusí fungovat na všech.

    * Nova.cz: Přepracováno na aktální verzi stránek.

    * Music.Stream.cz: Momentálně nefunkční.

    * VideaCesky.cz: Aktualizováno na další tvar vloženého downloaderu.

    * YouTube.com: Podpora pro URL ve tvaru http://www.youtube.com/watch_popup?v=b5AWQ5aBjgE.

    * Zakulisi.cz: Opraven zapomenutý testovací kód, kvůli kterému se stahovalo 
      stále stejné video.

    * Přeorganizována dokumentace. Seznam podporovaných serverů byl přesunut
      do samostatného souboru providers.txt.

    * Opravena command-line verze, aby u videí bez známé délky zobrazovala
      aspoň dosud přenesená data (dosud nezobrazovala nic).

    * Klávesou ENTER a/nebo dvojklikem na stáhnutý film se tento film přehraje
      ve výchozím přehrávači médií. (Dvojklik už fungoval dříve, ale jen ve VCL
      verzi programu.)

    * Klávesou CTRL+E se otevře adresář, do kterého se aktuálně vybrané stáhlo.

    * Pokud dojde při startu k chybě načítání konfiguračního souboru, program
      na to upozorní a vytvoří nový soubor.



  v0.80:

    * Nový poskytovatel: HardSexTube.com (porno).

    * Nový poskytovatel: Zmozek.cz.

    * CeskaTelevize.cz, CT24.cz: Předěláno na aktuální tvar stránek. Měla by
      fungovat všechna videa i na všech podstránkách, snad.

    * XHamsher: Aktualizován na současný přehrávač.

    * Opraveny chyby při překladu v Delphi 2009.



  v0.79:

    * Nový poskytovatel: CKKlic.cz.

    * Nový poskytovatel: Multimedia.vse.cz.

    * Nový poskytovatel: VKontakte.ru.

    * Nový poskytovatel: ZDF.de.

    * CeskaTelevize.cz: Podpora pro videa tvořená více částmi (např. Sama
      doma 29.3.2011). Nyní už by měla být stahována nejkvalitnější verze
      videa (nakonec nebyla chyba na serveru ale u mě - open-source model
      zjevně nefunguje, protože i přes dostupnost zdrojáků na chybu nikdo 
      nepřišel...).

    * Markiza.sk: Podpora pro doma.markiza.sk.

    * SerialyCZ.cz: Podpora pro další typ vložených videí.

    * VideaCesky.cz: Podpora pro videa přehrávaná přes přímé odkazy. Podpora
      pro videa chybně zadaná s mezerou na začátku. Podpora pro konverzi
      titulků do formátu SRT (standardně zapnutá, lze ji vypnout nastavením
      convert_subtitles, viz dokumentace).

    * ZkoukniTo.cz: Přidána podpora pro embedded adresy.

    * Přepracována práce s titulky u serverů odkazujících na cizí obsah (např.
      VideaCesky.cz): Preferují se titulky z odkazujícího serveru, teprve
      v případě, že neexistují, se využije titulků odkazovaného serveru. Dosud
      to bylo naopak.

    * Změna práce s podporou pro automatické použití HTML parseru (viz verze
      0.77) v případě, že je monitorován clipboard (verze 0.71): Dosud to
      vedlo k neočekávanému zakládání konfiguračního parametru, teď už ne.

    * Zahájeno čištění kódu na nejnovější standardy.



  v0.78:

    * Nový poskytovatel: CNBC.com.

    * Nový poskytovatel: i-Concerts.com.

      - Zatím jen free verze bez playlistů a podobně.

    * Nový poskytovatel: PracticalMethod.com.

    * Nový poskytovatel: Proglas.cz.

    * Nový poskytovatel: VideoPortal.sf.tv.

    * Byly aktivovány "generické" downloadery pro protokoly RTMP (RTMPE,
      RTMPT, RTMPTE) a MMS (MMSH, RTSP). To znamená, že do YTD lze nyní vložit
      i URL těchto protokolů (např. "mms://netshow.play.cz/proglas/audio_15681.wma"
      nebo "rtmp://iconcerts.infomaniak.ch/icpreview/mp4:trk-09-black_kids_nme_awards_shows-001_site_16-9-2500.mp4")
      a program je možná stáhne (pokud to server dovolí) - YTD se tak vlastně
      chová jako velmi zjednodušený RTMPDUMP resp. MSDL (podle použitého 
      protokolu). Základní nevýhody tohoto přístupu jsou dvě:
        1) Není k dispozici "hezké" jméno videa, soubory se ukládají pod 
           vnitřním ID poskytovatele.
        2) Ze serverů, které vyžadují další parametry kromě URL, se tímto 
           způsobem stahovat nedá. Použijte na ně přímo RTMPDUMP nebo MSDL,
           ty dovolují specifikovat i všechny potřebné parametry.
      Základní výhodou je, že je takto možné stahovat i z mnoha serverů,
      které v YTD přímo podporovány nejsou (např. Proglas.cz).

    * Barrandov.tv: Stahování je momentálně nefunkční, protože poskytovatel
      přešel na nový přehrávač a šifrované přenosy, takže neumím zjistit, co
      ode mě vlastně očekává. Pokud by někdo uměl zprovoznit RTMPSUCK (jde
      o součást projektu RTMPDUMP) tak, abych se dostal k datům, mohlo by 
      stahování opět fungovat.

    * CeskaTelevize.cz: Opět zprovozněny pořady (www.ceskatelevize.cz/porady).

    * Zakulisi.cz: Snad opravena náhodná chyba "Access Violation". Vypadá to
      na nějakou chybku přímo v Delphi 5, kvůli které se v určitých typech
      řetězcových operací přepíše paměť. Moje oprava snad chodí, ale protože
      se i chyba vyskytovala náhodně, nemohu to spolehlivě ověřit.

    * Aktualizován slovenský překlad (opět V. Kubala, díky).



  v0.77:

    * Nový poskytovatel: DancingBear.com (porno).

    * Nový poskytovatel: Denik.cz.

      - Podporovány jsou i všechny regionální varianty, audio i video.

    * Nový poskytovatel: FunnyOrDie.com.

    * Nový poskytovatel: iDnes.cz.

      - Implementace je řešena poměrně brutálním způsobem: natvrdo se používá
        konkrétní streamovací server místo serveru, o který si řekne samotný
        iDnes. Bohužel je to nezbytné, protože ten správný oficiální server
        nefunguje...

    * Nový poskytovatel: PBS.org.

    * Nový poskytovatel: Sefka.cz, Sefka.sk.

      - Přidání budoucích Prima-Joj projektů bude triviální záležitost.

    * Nový poskytovatel: Sme.sk.

    * Nový poskytovatel: Zakulisi.cz (porno).

    * FreeCaster.tv: K existující podpoře pro HTTP streamy byla přidána ještě
      podpora pro RTMP streamy, které jsou také u některých videí využívány.

    * N-Joy.cz: Rozšířeno o podporu pro stahování audia, podporu pro Right 
      Now (audio i video) a podporu pro streamy na bázi protokolů MMS/RTSP
      (ale tohle není vyzkoušené, protože jediné takové video, které jsem
      našel, nefunguje ani přímo ve Flashi).

    * Nova.cz: Bylo zprovozněno video "Ordinace v růžové zahradě 2, 250. díl"
      (a možná i některá jiná). Problém s videem je, že na serveru není k
      dispozici ve vysoké kvalitě, ve které se program snaží stahovat, a
      server přesto nesprávně informuje o úspěšném stažení. Problém byl
      vyřešen dvěma způsoby:

      1. V konfiguračním souboru lze nastavit, že se z Novy má stahovat v 
         nízké kvalitě místo ve vysoké. Viz dokumentace, hledejte <nova_cz>.

      2. Pokud jsou zapnuty "špinavé hacky" (což ve standardní konfiguraci
         jsou), YTD se pokusí tuto situaci detekovat a rovnou automaticky
         stáhnout nízkokvalitní verzi. Podotýkám, že skutečně *jde* o "špinavý
         hack", takže si nestěžujte, že se to chová divně (například se nemění
         přípona souboru, stále zůstává .mp4).

    * Servery opravené na aktuální stav:
      - Hasici150.tv.
      - MTV.com (stejně nefunguje, viz "handshake" poznámka níže).
      - RedTube.com (porno).
      - TotallyCrap.com.
      - UStream.tv.
      - WordPress.tv.

    * Dočasně nefunkční servery:
      - CrunchyRoll.com: vyžaduje autentizaci Flash přehrávače.

    * Mnoho serverů používajících protokol RTMP nyní nejde stahovat - při
      pokusu o download zapíší do logu varování "HandShake: Type mismatch: 
      client sent 6, server answered 9" a následně chybu, "handshake failed".
      Je to způsobené tím, že tyto servery už vyžadují Flash verze 10 a ten
      zatím není RTMPDUMPem podporovaný (viz http://stream-recorder.com/forum/rtmpdump-does-not-start-error-handshake-type-t8603.html).
      Až to RTMPDUMP začne podporovat, bude to zakomponováno i do YTD. Zatím
      se s těmito servery nedá nic dělat.

    * Podpora pro automatické použití HTML parseru na neznámá URL: pokud do
      YTD zadáte neznámou adresu, program se pokusí vyhledat v ní známé adresy
      stejně, jako kdyby ta adresa byla zadána parametrem -s (resp. tlačítkem
      "Přidat URL z HTML stránky"). Tím je zajištěna jednoduchá podpora pro
      servery jako Zive.cz, Vlaky.net a mnohé další, které se odkazují např. na
      YouTube. Staré chování (YTD ověří, jestli jde o známou adresu, a když ne,
      tak hned skončí s chybou) můžete nastavit parametrem -ah-, nastavením 
      <auto_try_html_parser> v konfiguračním souboru nebo v grafické verzi v 
      nastaveních.

    * Odstraněna zdvojená přípona souborů u vnořených downloaderů.

    * Při přepínání aplikací pomocí ALT+TAB se zobrazuje správná ikonka.

    * Podpora pro verze YTD vyšší než 0.99.

    * Překompilována knihovna RTMPDUMP_DLL tak, aby používala více osekanou
      (a menší) verzi PolarSSL. Tím jsem získal nějakých 27 KB na velikosti
      archívu, aniž by to mělo viditelně ovlivnit funkčnost (vyřazeny jsou
      různé ladící tisky a několik málo šifrovacích algoritmů, které se stejně
      v RTMPDUMPu nepoužívají). Kdybyste přesto narazili na problém (jiný než
      "handshake problém" výše), můžete použít RTMPDUMP_DLL z předchozích
      verzí YTD. Ale neočekávám to, vyzkoušel jsem snad všechny servery
      používající RTMP a všechny chodí.

    * Hlavní (portable) konfigurační soubor YTD.XML se nyní hledá napřed v 
      aktuálním pracovním adresáři a teprve pokud tam nebyl nalezen, tak v
      adresáři s YTD.EXE. To umožňuje mít několik různých konfigurací, aniž by
      bylo třeba mít několik kopií YouTube Downloaderu. Na vedlejším 
      (ne-portable) konfiguračním souboru se nic nemění, je stále v adresáři 
      profilu.



  v0.76:

    * CeskaTelevize.cz: Předchozí úprava znefunkčnila staré iVysílání a další
      alternativní přehrávací mechanismy.



  v0.75:

    * CeskaTelevize.cz: Přidána podpora pro pořady, které běží v IFRAME (např.
      Diagnóza).

    * YouTube.com: Přidána podpora pro videa, u kterých majitel autorských
      práv vyhradil přehrávání jen pro určité servery (mnoho hudebních klipů
      je vydaných právě v tomto formátu).

      Podpora playlistů upravena na aktuální tvar stránek.

    * Opraveno nefunkční CTRL+C (zkopírovat URL do schránky) v grafickém 
      rozhraní.



  v0.74:

    * Nový poskytovatel: 123Video.nl.

    * Nový poskytovatel: Hrej.cz.

      - Některá videa jsou hostovaná na jiných serverech, např. na YouTube, 
        a nelze je stahovat přímo. Můžete ale použít funkci "Přidat URL z 
        HTML stránky".

    * Nový poskytovatel: MojeTelevize.cz.

      - Fungovat by měly všechny projekty hostované na serveru, včetně např.
        Adra.MojeTelevize.cz a dalších.

    * Nový poskytovatel: Sport.cz.

    * Nový poskytovatel: TV4Play.se.

      - Podporován je pouze zdarma dostupný obsah.

    * Nový poskytovatel: Video.Tiscali.cz.

    * Česká televize: Stahování nyní ve výchozím stavu probíhá v režimu 
      "živé video", kdy se sice stahuje mnohem pomaleji, ale stáhnutý soubor
      se zdá být v pořádku. V konfiguračním souboru lze přepnout zpátky na
      stahování "jako soubor", které běží podstatně rychleji, ale dokud bude
      serverová část ČT napsaná tak, jak je teď, tak povede k porušeným
      souborům. Popis je uveden v dokumentaci (hledejte <live_stream>).

    * Joj.sk: Upraveno na aktuální tvar přehrávače.

    * Markiza.sk: Podpora pro videa tvořená více částmi (např.
      http://video.markiza.sk/archiv-tv-markiza/parti269-ka/54516).

    * StreetFire.net: Dočasně nefunkční.

    * YouTube.com: Upraven formát titulků - formát času vyžaduje, aby 
      oddělovačem desetinných míst u sekund byla čárka a ne tečka, kterou
      jsem tam měl původně.



  v0.73

    * Česká televize:

      1) Špatná zpráva: Nový web České televize je sice od minulé verze
         podporovaný, ale na stáhnuté pořady se nedá dívat, protože bylo
         streamování ze strany ČT implementováno naprosto šíleně. Výsledkem
         je, že sice mohu požádat o libovolný stream a server mi sdělí, že
         mi ho rád pošle, ale ve skutečnosti mi pošle úplně jiný stream a
         tomu bude během přehrávání měnit parametry. Názory na to, nakolik
         jde o chybu nebo vlastnost, se různí, ale výsledek je jeden: dokud
         si to ČT neopraví, tak YTD její streamy nebude umět pořádně stáhnout.
         Je zbytečné mě na to upozorňovat nebo žádat o opravu, já s tím nic
         udělat nemůžu. (Vlastně je ještě jedna možnost: když to implementuje
         někdo jiný, kdo fungování serverů ČT rozumí lépe než já. Pak to rád
         do programu zařadím.)

      2) Dobrá zpráva: Naštěstí ještě funguje staré iVysílání na adrese
         http://www.ceskatelevize.cz/ivysilani-jako-driv/ (díky Pepovi a
         Pájovi, kteří mě na tento fakt upozornili). Tato verze tedy zavádí
         podporu pro staré iVysílání na této nové URL.

      3) Druhá dobrá zpráva: ČT část svých pořadů provozuje i přes server
         Stream.cz, který funguje na starém dobrém HTTP protokolu, který YTD
         zvládá bez nejmenších potíží. Můžete tedy videa stahovat i odtamtud.



  v0.72

    * Nový poskytovatel: 1hd.ro.

    * Nový poskytovatel: DotSub.com.

    * Nový poskytovatel: Music.Stream.cz.

    * Nový poskytovatel: RockstarGames.com.
      Pozor, poskytovatel vyžaduje použití protokolu HTTPS, tudíž musíte mít
      v cestě (path) OpenSSL knihovny LIBEAY32.DLL and SSLEAY32.DLL.

    * Nový poskytovatel: SerialyCZ.cz.

    * Nový poskytovatel: SportStream.cz.

    * Nový poskytovatel: Tyzden.sk.

    * CeskaTelevize.cz: Aktualizováno na novou podobu iVysílání.

    * CestyKSobe.cz: Podpora pro alternativní způsob vkládání video přehrávače,
      viz např. http://cestyksobe.cz/novinky/novinky/544.html.

    * iPrima.cz: Podpora pro pořady, které jsou na Stream.cz hostovány, ale
      nemají tam samostatně přístupnou stránku (např. 
      http://www.iprima.cz/videoarchiv/42037).



  v0.71

    * Nový poskytovatel: AdultLoop.com (porno).

    * Nový poskytovatel: BandZone.cz.

    * Nový poskytovatel: DUB.cz.

    * Nový poskytovatel: PrahovaHD.ro (pouze on-demand videa).

    * Nový poskytovatel: Rtl.nl.

    * Nový poskytovatel: StastneVdovy.cz.

    * Nový poskytovatel: Super.cz.

    * Nový poskytovatel: TVS.pl.

    * Nový poskytovatel: WeGame.com.

    * iPrima.cz: Opraven název videa.

    * Nova.cz: Aktualizováno na novou podobu archívu.

    * STV.sk: Přepracováno na aktuální stav. Pozor, server je extrémně
      nestabilní a víc nefunguje než funguje (i pro běžné online sledování,
      není to jen problém downloadu).

    * Bylo přidáno nové nastavení pro sledování obsahu schránky (clipboardu).
      Ve standardním stavu je vypnuté, ale pokud ho zapnete, bude YouTube
      Downloader monitorovat změny v clipboardu a automaticky zařazovat známá
      URL do seznamu ke stažení.

    * Pokud nebyla ve Windows nastavena asociace na editování .xml souborů,
      nefungovalo tlačítko "Upravit konfigurační soubor". Nyní se v takovém
      případě otevře konfigurační soubor v Notepadu.

    * Program má novou ikonku od uživatele KRYSPIN z Hofylandu. Výhodou je
      mimo jiné i to, že vypadá dobře ve všech velikostech.



  v0.70

    * Opravena chyba Access Violation při překreslování seznamu downloadů,
      která se vloudila do minulé verze.

    * Doplněna čeština do dvou položek menu, které ještě byly anglicky.



  v0.69

    * Nový posktyovatel: AutoSalonTV.cz.

    * Blip.tv: Podpora pro playlisty.

      Pozn.: Načítání obsahu playlistu probíhá bez jakéhokoliv výstupu a může
      u některých playlistů (např. http://thespoonyone.blip.tv) trvat i dost
      dlouho. Nenechte se znervóznit tím, že se zdánlivě nic neděje.

    * Facebook.com: Přidána podpora pro videa, u kterých není uvedena kvalita.

    * Markiza.sk: Aktualizováno na nový webový přehrávač.

    * Novinky.cz: Upravena podpora pro videa uvnitř článků.

    * Formulář "Nastavení" (F9) byl podstatně rozšířen. Nyní už obsahuje
      skoro všechna nastavení, která jsou v konfiguračním souboru k dispozici,
      mimo jiné nastavení proxy serveru nebo možnost dodatečně zapnout nebo
      vypnout zjišťování nových verzí při startu programu. 
      
      Na formuláři nastavení jsou také k dispozici tlačítka pro vytvoření
      zástupce na ploše nebo ve Start menu.

    * Opraveny nekompatibility s Delphi 2009 (týká se to jen těch, kdo si 
      YTD kompilují sami, protože produkční verze je kompilována Delphi 5):

      - Aplikace spadne s Access Violation nebo jinou chybou, pokud je zapnuta
        WinAPI verze grafického prostředí.

      - Nefunguje zjišťování, jaká verze YTD je k dispozici na internetu.

    * Tlačítko "Stop" v grafické verzi programu fungovalo ve skutečnosti jako
      pauza, ne jako zastavení.

    * Přenosný režim v řadě situací "přebil" režim nepřenosný. Nyní už by měl
      vždy běžet skutečně ten režim, který si uživatel vybral.



  v0.68

    * FreeCaster.tv: Upraveno na novou podobu stránek.

    * Novinky.cz: Podpora pro videa uvnitř článků.

    * Stream.cz: Upraveno na novou podobu stránek. To také opravuje všechny
      servery, které Stream využívají, např. iPrima.cz nebo N-Joy.cz.

    * YouTube.com: Titulky opět fungují.
      Přidána podpora pro embedded tvar URL.

    * CLI: Častejší informace o stažených datech, zejména u dlouhých videí.



  v0.67

    * Opraveno nepřekreslování seznamu downloadů pod Windows 7.



  v0.66

    * Opravena chyba při spouštění programu na Windows 7.



  v0.65

    * Nový poskytovatel: CD.cz.

    * Nový poskytovatel: ThatVideoSite.com.

    * Nový poskytovatel: WordPress.tv.

    * Nový poskytovatel: Yikers.com.

    * UStream.tv: Aktualizován název videa.

    * Byla doplněna alternativní verze grafického rozhraní, postavená na čistém
      Windows API místo na Delphovském VCL. Chování obou je téměř stejné, s
      výjimkou případných nových chyb v novém rozhraní, ale API verze má 
      několik významných výhod:

      - Je o mnoho kratší: Instalátor se zkrátil asi o 125 KB, samotná aplikace
        před kompresí UPX o téměř 400 KB. To byl pro mě hlavní důvod, proč se
        do přepisu pouštět.

      - Pokud máte knihovnu Common Controls ve verzi aspoň 6.0 (Windows XP ji
        mají od výrobce, do starších systémů se dá doinstalovat), je odstraněno
        blikání seznamu downloadů.

      - Jde zkompilovat i FreePascalem, tzn. pokud si chcete program upravit 
        a nemáte přímo Delphi, nebudete ochuzeni o grafické prostředí.

      Naproti tomu má i dva nedostatky:

      - Není zdaleka tak dobře odladěné jako staré GUI. To je dané množstvím
        uživatelů a dobou používání a postupně to bude opraveno.

      - Z neznámých důvodů zatím nefunguje pod Delphi 2009, protože listview
        zobrazující seznam downloadů velmi rychle zahltí celou paměť. Kdyby
        někdo přišel na příčinu, velice by mě zajímala.

      Pokud chcete nové GUI vypnout, stačí v souboru Source\YTD.inc smazat
      "{$DEFINE GUI_WINAPI}" a program překompilovat.

    * Soubory videí stahovaných HTTP protokolem jsou nyní otevřeny ve sdíleném
      režimu. Díky tomu je možné už v průběhu downloadu spustit přehrávání
      videa.

    * V souvislosti s přepisem GUI byla prováděna řada optimalizací, na délku
      kódu i na jeho čistotu.



  v0.64

    * Nový poskytovatel: MTV.com.

    * GameAnyone.com: Opraveno na aktuální stav webu.

    * KeezMovies.com: Opraveno na aktuální stav webu.

    * Nova.cz: Kapituloval jsem a povolil i URL se dvěma lomítky za Nova.cz.

    * SpankWire.com: Opraveno na aktuální stav webu.

    * Aktualizována slovenská jazyková verze na stav z verze 0.63.

    * Opravena chyba, kdy se při vkládání nové adresy pomocí INS vždy použila
      původní adresa z clipboardu, i když ji uživatel ve vkládacím formuláři
      změnil.

    * Opravena chyba ve výchozím konfiguračním souboru (vytvoří se v případě, 
      že neexistuje soubor ytd.xml): konverze do AVI/H264 byla nadefinována,
      ale nebyla dostupná uživateli.

    * Pokud je jméno souboru (včetne cesty) příliš dlouhé, bude oříznuto tak,
      aby mělo maximálně 255 znaků standardně povolených ve Windows.



  v0.63

    * Nový poskytovatel: Beeg.com (porno).

    * Nový poskytovatel: Brazzers.com (porno).

    * Nový poskytovatel: Fishki.ru.

      Pozn.: Je sice možné detekovat název, jak je napsaný ve stránce, ale
      vznikl by problém, jak z něj udělat funkční název souboru - na to by
      musel YTD být zkompilovaný pomocí Delphi 2009, což má řadu nevýhod
      (velikost programu, nepodpora pro stará Windows atd.). Proto se zatím
      přebírá původní název souboru a titulek videa se ignoruje. Pokud máte
      nějaký nápad, jak ruštinu jednoduše a spolehlivě převést do latinky,
      rád ho implementuji.

    * Nový poskytovatel: Hasici150.tv.

    * Nový poskytovatel: Loupak.cz.

    * Nový poskytovatel: NaStojaka.cz.

    * Nový poskytovatel: NBC.com.

    * Nový poskytovatel: Prima-Cool.cz.

    * Nový poskytovatel: RozzlobeniMuzi.com (server obsahuje i porno materiál).

    * Nova.cz: Přidána detekce případu, kdy bylo video ze serveru odstraněno
      (např. http://archiv.nova.cz/multimedia/pribehy-bez-scenare-zivot-na-vlasku-sedmy-dil.html).

    * GUI: Odstraněny ikonky pro jednotlivá nastavení; místo nich je nový
      samostatný formulář, na kterém jsou všechna grafická nastavení na 
      jednom místě (existuje spousta dalších nastavení, která nejdou měnit
      graficky a jsou uvedena v dokumentaci). 
      
      Vedlejším efektem je, že i v grafické verzi je nyní možné nastavit 
      režim "automaticky přejmenovávat" pro případ, že soubor se stejným 
      názvem už existuje.

    * Dokumentace doplněna o instrukce ke kompilaci programu ze zdrojových
      kódů. Kompilační skripty byly při té příležitosti vyčištěny (např. už
      není potřeba říkat, jakou verzi Delphi chcete použít).

    * Opravena chyba v AMFString.



  v0.62

    * Upravena komponenta pro práci s XML soubory, aby správně (podle XML
      specifikace) pracovala s kódováním souborů. To by mělo řešit všechny
      případy, kdy bylo video ukládáno se špatnou češtinou (posledně to mám
      hlášeno u http://archiv.nova.cz/multimedia/foto/okresni-prebor-8-dil-schuze.html).
      Je možné, že úprava něco rozhodí; když na nějaký takový případ narazíte,
      dejte mi vědět.

    * Nalezena a opravena příčina, která za jistých okolností (typicky pokud
      byl určen adresář pro downloady a v něm už existoval soubor se stejným
      názvem) vedla k chybě "Stahování do souboru XYZ nebylo povoleno". Hlášení
      samo existuje i nadále, protože signalizuje naprosto legitimní situaci,
      ale teď už by se mělo objevovat jedině v případě, že operační systém
      skutečně nedovolí zápis do souboru.



  v0.61

    * Nový poskytovatel: RTA.cz.

    * Nový poskytovatel: Sex-Doma.cz (porno).

    * Nový poskytovatel: TN.Nova.cz.

      Pozor: Nepodařilo se mi plně dekódovat způsob, jak se z URL článku dostat
      k URL videa. Z tohoto důvodu jsem použil velmi prasácký hack, který 
      postupně vyzkouší všechny servery, na kterých by video mohlo být. To je 
      za prvé pomalé, za druhé nespolehlivé a za třetí se snadno může stát, že 
      vás Nova za tento způsob útoku na jejich servery zabanuje.

    * Nový poskytovatel: Z1TV.cz.

    * CT24.cz: Podpora pro URL ve formátu
      http://www.ct24.cz/vysilani/2010/02/10/10159875412-210411058030210-11:35-milenium/

    * MojeVideo.sk: Nároky na URL byly příliš vysoké, v důsledku toho některá
      videa nešla stáhnout (např. http://www.mojevideo.sk/video/654a/eduard_mila_tomasovi_gen.html).



  v0.60

    * Nový poskytovatel: DrsnySvet.cz (jen některé zdroje).

    * Nový poskytovatel: MojeVideo.sk.

    * Nový poskytovatel: Qip.ru (jen embedded videa).

    * Nový poskytovatel: Studio-Plus.tv.

    * GameAnyone.com: Podpora pro videa hostovaná přímo na GameAnyone.com.
      Tato podpora se také týká všech ostatních poskytovatelů, kteří fungují
      primárně přes servery třetích stran, např. VideaCesky.cz nebo 
      OverStream.net.

    * YouTube.com: Opravena chyba EStreamError z minulé verze, kdy nešlo 
      stahovat videa, která titulky neměla.



  v0.59

    * CeskaTelevize.cz: Podpora pro videa na stránkách Pořadů (URL ve tvaru
      http://www.ceskatelevize.cz/porady/873537-hledani-ztraceneho-casu/207522161510013-filmy-z-vaclavaku/)
      - ovšem pozor, zdaleka ne každá stránka pořadů video obsahuje.

    * MustWatch.cz: Poskytovatel se přesunul na vlastní doménu.

    * YouTube.com: Podpora pro stahování videa v jiném než nejvyšším možném
      rozlišení. Nastavení je řešeno položkami v konfiguračním souboru, popis 
      je uveden v dokumentaci (<max_video_width>, <max_video_height>).

      Opět funkční uživatelské stránky (http://www.youtube.com/user/titanicpiano14).

      Opět funkční playlisty (http://www.youtube.com/view_play_list?p=90D6E7C4DE68E49E).

      Podpora pro stahování titulků. Standardně se stahují první nalezené
      titulky, v konfiguračním souboru ale můžete určit preferované jazyky
      a jejich pořadí. Titulky jsou standardně konvertovány do formátu .srt,
      protože YouTube používá vlastní speciální formát, ale tuto konverzi
      lze vypnout. Popis je v dokumentaci (<preferred_languages>, 
      <convert_subtitles>).

    * Změněna práce s titulky: Titulky se nyní stahují před videem, ne až po
      něm. Kromě toho proběhla řada dalších interních změn zejména u 
      poskytovatelů bez vlastní infrastruktury (VideaCesky.cz atd.), proto
      prosím hlaště případy, kdy se přestaly stahovat titulky tam, kde dříve
      fungovaly.

      Titulky jde nyní zakázat nebo povolit, jak globálně pro celou aplikaci,
      tak pro jednotlivé poskytovatele. Detaily jsou v dokumentaci
      (<subtitle_support>).

    * Umístění specifických nastavení poskytovatelů v konfiguračním souboru
      neodpovídalo dokumentaci ani vzorovým konfiguracím. Opraveno tak, aby 
      realita odpovídala dokumentaci i příkladům (<modules>).



  v0.58

    * Nový poskytovatel: PrazdninyVTelci.cz.

    * Nový poskytovatel: TubeSSS.com (porno).

    * OverStream.net: Přidána podpora pro titulky.

    * PublicTV.cz: Podpora pro pořady tvořené několika částmi (např.
      http://www.publictv.cz/cz/menu/3/videoarchiv/clanek-22184-jukebox-s-lenny/1935/)

    * TVcom.cz: Nenačítal se správně název obsahu.

    * VideaCesky.cz: Přidána podpora pro další tvar videa.

    * YouTube.com: Přidána podpora pro URL, ve kterých není ID videa prvním
      parametrem.

    * Přepsána podpora titulků tak, aby šla snadno implementovat pro libovolný
      server.

    * MSDL vráceno na verzi 1.2.7, protože se mi nedaří vzpomenout, jak se dá
      verze 1.2.7-r2 zkompilovat pod Windows.



  v0.57

    * Zapomněl jsem odstranit debugovací kód. Sice je neškodný, ale otravný.



  v0.56

    * Nový poskytovatel: NavratDoReality.cz
        - Pozor, podporována jsou pouze videa hostovaná přímo na serverech
          NavratDoReality.cz, nikoliv videa přehrávaná přes cizí poskytovatele.

    * Nový poskytovatel: TV7.cz

    * Další pokus o odstranění záhadných chyb "Stahování do souboru XY nebylo
      povoleno."

    * HTML soubor s odkazy (parametr -s) může nyní být i v kódování UTF-8
      nebo UTF-16.

    * YouTube Downloader je nyní kompatibilní s Delphi 2009.

    * Knihovna NativeXml aktualizována na verzi 3.10. To s sebou nese opravy
      češtiny u některých poskytovatelů, například u TV Barrandov.

    * Opravena skrytá chyba kompilačního skriptu (nefungovaly wildcards
      ve jménech kompilovaných souborů).



  v0.55

    * Komponenta TNativeXml měla nesprávnou výchozí hodnotu pro kódování,
      což vedlo k nesprávným názvům filmů na českých webech, na kterých
      se informace čtou z XML.

    * Úpravy pro kompatibilitu s Delphi 2009 způsobily neočekávanou chybu
      při práci s pamětí, která se projevila např. při stahování z TV Nova. 
      Nelze vyloučit, že jsou v programu ještě nějaké další podobné chyby.



  v0.54

    * iPrima.cz: Opět funguje. Navíc je podporován další formát URL.

    * Markiza.sk: Podpora pro TalentManii.

    * Další úpravy kódu pro dosažení kompatibility s Delphi 2009. Program jde
      nyní zkompilovat, ale nebude fungovat, protože několik klíčových částí
      ještě není přepsáno.



  v0.53

    * Vladimír Kubala (kubalav@gmail.com) vytvořil slovenský překlad.

    * Nový poskytovatel: OverStream.net

    * Nový poskytovatel: MustWatch.hztz.cz

    * Nový poskytovatel: CSmaTalent.cz, CSmaTalent.sk

    * VideaCesky.cz: Podpora pro další dva způsoby odkazování na videa.

      Některá videa jsou bohužel obtížně dostupná, protože server VideaCesky
      se příliš nezatěžuje úvahami, jestli dodržuje nějaké standardy, a s
      klidem dává do URL znaky, které tam nemají co dělat. Příkladem je
      http://www.videacesky.cz/skece-zabavne-scenky/george-carlin-%E2%80%93-nabozenstvi-je-kravina
      - takhle už je správně, ale VideaCesky to naprosto v pohodě odkazují
      s dlouhou pomlčkou místo aby ji správně zakódoval do posloupnosti
      %E2%80%93. No a některé browsery, například Internet Explorer a Opera,
      tuhle neplatnou adresu dál šíří přes clipboard. Použijte Firefox, ten
      vadné URL přijme, ale do clipboardu už ho zapíše správně zkonvertované.
      
      Definitivní oprava nebude k dispozici dříve, než program přepíšu na
      plnou kompatibilitu s Delphi 2009.



  v0.52

    * Nový poskytovatel: AlternativaTV.cz

    * Nový poskytovatel: PCPlanets.com
        - Poskytovatel by měl fungovat, ale vytrvale vrací HTTP chybu 403
          (forbidden). Stejně se ovšem chová i samotný flashový přehrávač,
          zřejmě tedy nejde o chybu v YTD ale buď o chybné video nebo např.
          nepodporovaný stát uživatele.

    * Upraven PerlRegEx tak, aby se Unicode kód používal pouze v Delphi 2009
      a novějších. Ve starších Delphi se tím ušetří nějakých 80 KB na 
      velikosti .exe souboru.

    * Probíhají postupné úpravy programu pro dosažení kompatibility s
      Delphi 2009.



  v0.51

    * Změna licenčních podmínek: YouTube Downloader už není distribuován pod
      licencí GNU GPL: podrobným zkoumáním GPL a licencí použitých knihoven
      se ukázalo, že nemám právo program pod GPL vydat. Použita je nyní
      tzv. "nová BSD licence" s tím, že komponenty třetích stran v adresáři
      Source/Lib se řídí licencemi svých autorů. Podrobnosti jsou uvedeny
      v dokumentaci.

    * GUI: Konvertory jsou nyní standardně v neaktivovaném stavu a než je budete
      moci použít, musíte je v konfiguračním souboru aktivovat. Je to proto,
      že mnoho uživatelů si nepřečetlo dokumentaci a rovnou si začali stěžovat,
      že jim konvertory nefungují (což bylo a je očekávané chování, protože
      se konvertory musí napřed nastavit). Postup aktivace je uveden v
      dokumentaci.

    * GUI: Je rozlišen chybový stav "Nepodařilo se spustit konvertor" a 
      "Konvertorse spustil, ale nahlásil chybu".

    * GUI: Při pokusu o přidání nepodporovaného URL je zobrazena chybová 
      zpráva.

    * Česká televize: 
      - Podpora pro reklamy (přesněji, pro jejich přeskakování).
      - Podpora pro URL typu: http://www.ceskatelevize.cz/program/10252893246-07.08.2010-08:32-24-prizma.html
      - Podpora pro URL typu: http://www.ct24.cz/regionalni/87267-vrchlabsky-zamek-ma-vlastni-miniaturu/

    * VideaCesky.cz: Podpora pro videa, která jsou hostována přímo na serveru,
      ne na YouTube (napr. http://www.videacesky.cz/ostatni/ceska-republika-narod-pivaru).

    * MSDL aktualizováno na verzi 1.2.7-r2.



  v0.50

    * Při prvním spuštění grafické verze (tzn. v okamžiku, kdy zjistí, že
      neexistuje konfigurační XML soubor) se vás program zeptá na několik
      nastavení, která mohou ovlivňovat vaše soukromí. Věnujte prosím těmto
      dotazům svoji pozornost.

    * Při startu grafické verze programu se automaticky testuje dostupnost
      novější verze. Pokud vám to vadí, je na to nastavení v konfiguraci.
      Popis je v dokumentaci k programu.

    * Kompletně přepracován systém ukládání a načítání konfiguračních údajů.
      Místo původní poněkud schizofrenní kombinace INI souboru a registru je
      nyní použit jeden XML soubor, uložený buď v adresáři programu nebo
      v uživatelském profilu, podle toho, jestli YouTube Downloader pužíváte
      jako přenositelnou (portable) aplikaci nebo normální. Podrobnosti jsou
      uvedeny v dokumentaci.

      Staré konfigurační údaje v INI souboru a v registrech už nebudou
      používány.

    * Podpora pro konverzi videa nebo jakékoliv jiné akce po jeho úspěšném
      stáhnutí. Detaily, jak funkci používat, jsou popsány v dokumentaci v 
      sekci "Konverze stáhnutých souborů", v sekci "Konfigurace" je v části
      <converters> popsáno, jak definovat vlastní konvertovače nebo měnit
      parametry předdefinovaných.

    * GUI verze má nyní speciální tlačítko, pokud by snad někdo chtěl
      přispět opravdovými penězi na další vývoj programu. Žádný strach,
      aplikace je a bude free i bez příspěvků - pro mě jde spíš o způsob
      sledování, kolika lidem program připadá užitečný, než o zdroj příjmů
      (nehledě na to, že bych se nerad dostal do situace, kdy by příspěvky
      přerostly hranici a já je musel danit).

    * GUI verze má dále tlačítko pro nahlášení URL, které by stáhnout jít
      mělo, ale nejde. Podmínkou pro využití této funkce ale je, abyste
      používali aktuální verzi programu. Před hlášením si prosím ověřte, že
      chyba opravdu je v programu - speciálně, že vám funguje připojení k
      internetu a že dotyčné video funguje, pokud si ho necháte zobrazit
      normálně v prohlížeči. Děkuji za pochopení.

      Hlášení chyb probíhá přes speciální webový formulář, který bude mít
      už v okamžiku otevření předvyplněné všechny nezbytné parametry.
      Doporučuji vám ale vyplnit i nepovinné pole "Popis", a - pro případ,
      že budete chtít odpověď, nebo já budu potřebovat další upřesnění
      - e-mail.

    * Podrobnější chybová hlášení v GUI verzi.

    * Opravena chyba, která náhodně (tzn. já sám jsem na ni poprvé narazil
      až v této verzi, přestože chyba je tu s námi už od verze 0.12) 
      způsobovala pády programu po skončení downloadu.

    * Noví poskytovatelé:
        - AngryAlien.com
        - Blennus.com
        - Bolt.com (BoltAgain.ning.com)
        - Current.com
        - Dachix.com (porno)
        - DevilDucky.com
        - EmpFlix.com (porno)
        - EVTV1.com
        - Grinvi.com (porno)
        - NothingToxic.com
        - Revver.com
        - SlutLoad.com (porno)
        - Spankwire.com (porno)
        - TnaFlix.com (porno)
        - TotallyCrap.com
        - YouJizz.com (porno)

    * Barrandov.tv: Používá se vhodnější přípona .flv místo původního .f4v.

    * Break.com: Podpora pro dvě varianty odkazů na embedded verzi.

    * VideaCesky.cz: Přidána druhá varianta pro zobrazení videa, tím by se
      měla zprovoznit většina filmů, které dosud nefungovaly.

    * PornHub.com: Podpora pro odkazy na embedded verzi. Opraveno stahování
      u normální (HTML) verze.

    * Další velká programátorská změna: místo původního TjanXmlParser2 je
      použita komponenta TNativeXml, která se stále vyvíjí, podporuje i nové 
      verze Delphi a podstatně lépe vyhovuje standardům XML. Stejně jako v
      případě regulárních výrazů v minulé verzi to může vést k některým 
      nefunkčním poskytovatelům, ale drtivou většinu jsem jich zkoušel a
      fungovaly.

    * Opět zprovozněna kompilace pod FreePascalem. V souboru Source\build.txt
      je popis, jak YTD zkompilovat. Do Source byly přesunuty i skripty pro
      kompilaci programu.



  v0.40

    * Nový poskytovatel: Cas.sk.

    * Nový poskytovatel: MediaSport.cz.

    * Free.zoznam.sk: Video se ukládalo s příponou .php.

    * LiveLeak.com: Podpora pro embedded verze odkazů.

    * MSFotbal.ct24.cz: Původní odkazy (na vlastní subdoméně) už neexistují,
      k videu se ale stále dá dostat přes "obecné" odkazy CT24.cz.

    * Rozhlas.cz: Opět funguje (sice už není potřeba, protože na stránkách
      je přímý odkaz na download, ale když už byl kdysi podporován...). Byla
      opravena chyba, kdy se za jistých okolností mohly soubory nechtěně 
      přepisovat.

    * YouTube.com: Opět funguje, po další změně stránek YouTube.

    * Grafická verze: Okna pro výběr souboru (při ukládání nebo načítání)
      používají grafickou podobu odpovídající Windows, ve kterých jsou spuštěné
      - dosud používaly zobrazení odpovídající Windows 98.

    * CLI verze: Podpora pro návratové kódy (errorlevel). Popis je uveden v
      příslušné sekci v dokumentaci.

    * CLI verze: Chyba v parametrech nebo "zobrazovací" parametry (-?, -v, -l)
      ukončí další zpracování příkazové řádky a vyskočí z programu.

    * Drobné optimalizace velikosti programu.

    * Opraveno ukládání seznamu nestažených souborů: pokud byl seznam prázdný,
      nepřepsal už dříve uložený seznam.

    * Program nyní používá pro regulární výrazy komponentu TPerlRegEx místo
      původní DPCRE. To sice může vést k problémům u některých poskytovatelů, 
      kteří dříve fungovali (řadu z nich jsem testoval a fungují, ale 
      neověřoval jsem všechny), ale umožnilo mi to obejít se bez knihovny
      PCRE.DLL a hlavně to bude mnohem lépe udržovatelné do budoucnosti,
      protože TPerlRegExp je celkem pravidelně aktualizován a oficiálně
      podporuje i nové verze Delphi (2009 a 2010).



  v0.39

    * GUI verze: Automaticky se ukládá seznam videí ke stažení, a tento seznam
      se automaticky načítá při startu programu. To znamená, že můžete YouTube
      Downloader ukončit a později pokračovat tam, kde skončil (videa se ovšem
      budou stahovat opět od začátku, navazování přerušeného spojení není
      podporováno).

      Pokud je YouTube Downloader spuštěn v portable režimu (nastavení
      DontUseRegistry je v INI souboru nastaveno na 1) a tato funkce má 
      fungovat, musí být INI soubor zapisovatelný.

    * Aby byla zajištěna správná funkce předchozí funkčnosti na všech Windows,
      byla změněna výchozí hodnota DontUseRegistry na 0 - "používat registry".
      Pokud chcete provozovat YouTube Downloader v portable režimu, MUSÍTE
      vytvořit INI soubor a zapsat do něj DontUseRegistry=1 (viz dokumentace).

    * VideaCesky.cz: Některá videa nešla stáhnout.

    * Nový zdroj: Aktualne.cz (Aktualne.Centrum.cz).

    * Nový zdroj: AutoTube.cz.

    * Nový zdroj: Bomba.cz.

    * Nový zdroj: DeutscheBahn.com.

    * Nový zdroj: GameAnyone.com.

    * Nový zdroj: iHned.cz.

    * Nový zdroj: Novinky.cz.

    * Nový zdroj: PublicTV.cz.



  v0.38

    * Přidána podpora pro další varianty URL u msfotbal.ct24.cz.

    * Aktualizována podpora YouTube na změněnou strukturu z 17.6.2010.

    * GUI: Dvojklikem na stáhnutém videu se toto video spustí ve výchozím
      přehrávači (podle formátu).

    * Nový zdroj: CestyKSobe.cz



  v0.37

    * Několik úprav v kódu výrazně zkracuje command-line verzi YTD - pokud
      je zakázáno grafické rozhraní, klesne délka programu na necelou
      polovinu původní velikosti.

      Následovat budou úpravy pro zkrácení GUI verze.

      (Ano, já vím, že dnes jsou tak velké disky, že ušetřených 100 KB
      nikoho nezajímá. Ale co se dá dělat, mě se malé programy líbí...)

    * Česká televize: Podpora pro videa uvnitř článků na ČT24, jako je např.
      http://www.ct24.cz/regionalni/87267-vrchlabsky-zamek-ma-vlastni-miniaturu/
      Je třeba zadat ne článek (URL výše), ale přímo URL videa, např.           
      http://www.ct24.cz/regionalni/87267-vrchlabsky-zamek-ma-vlastni-miniaturu/video/1/

      Podpora pro msfotbal.ct24.cz.

    * Nový zdroj: Slovenská televize.

    * Při testu na novou verzi (CLI: parametrem -v; GUI: v okně About) se
      nepoužíval proxy server, i když byl v INI souboru nastaven.



  v0.36

    * Uvolněna kontrola při konverzi řetězců mezi kódováními - program nebude
      vyhazovat chybu konverze v případě, že narazí na neznámý znak, prostě
      ho nahradí jiným. (Řeší nestabilní chování České televize, která se
      někdy stáhne a někdy - se stejným URL - zase ne.)

    * Podpora pro lokalizace. 

      - Využívání existujících překladů: Ve výchozím stavu použije program
        jazykovou verzi podle nastavení Windows, lze si ale vynutit konkrétní
        jazyk pomocí nastavení Language v INI souboru (viz dokumentace).

      - Tvorba vlastních překladů: Postupujte prosím podle příslušné sekce 
        v dokumentaci.



  v0.35

    * Nově podporované servery:
        - 5min.com
        - eHow.com
        - ExtremeTube.com (porno)
        - Flickr.com
        - FreeVideo.ru
        - GrindTV.com
        - KeezMovies.com (porno)
        - Muzu.tv
        - RingTV.com
        - SevenLoad.com
        - Spike.com
        - Stagevu.com
        - StupidVideos.com
        - TodaysBigThing.com
        - University of Minnesota (ima.umn.edu)



  v0.34

    * Odstraněno zapomenuté konzolové okno při spouštění GUI verze.

    * Aktualizována podpora MySpace. Pozor, týká se pouze videí hostovaných
      přímo na serveru MySpace - jsou i taková, co jsou hostována jinde (např.
      na Hulu.com), a ta stáhnout nejdou.

    * Podpora pro TV Noe (http://tvnoe.tbsystem.cz).

    * Podpora pro FreeCaster.tv.

    * Podpora pro Mpora.com.

    * Podpora pro VitalMtb.com.

    * Pokud uživatel odsouhlasí přepsání existujícího souboru, pokusí se YTD
      tento soubor smazat a teprve potom do něj začne zapisovat. (Jde o pokus,
      jak obejít zvláštní chování Windows 7, které nechtějí dovolit zápis do
      existujícího souboru).



  v0.33

    * Stream.cz: Podpora pro HQ videa.

    * Joj.sk: Adresa pořadu detekuje další dva možné způsoby, jak se u Joj
      zapisují informace o pořadu. Dosavadní pořady se tak dokonce mohly
      (a nemusely) stahovat špatně - mohlo se stáhnout něco jiného, než co
      jste stáhnout chtěli. Doporučuji downloady z Joj.sk důkladně sledovat
      a hlásit případné chyby, protože není vyloučeno, že Joj bude mít ve 
      svých kódech nějakou další divočárnu.

      Tím by mělo být opravené i případné nestahování HQ verze.

    * VideaCesky.cz: Spolu s filmem se stahují i titulky.

    * Ve zdrojovém kódu knihovny MSDL chyběly soubory .po potřebné pro
      kompilaci.

    * Podpora pro proxy servery. V INI souboru jsou pro ně položky ProxyHost,
      ProxyPort, ProxyUser a ProxyPassword. Viz dokumentace.



  v0.32

    * Mírně přeuspořádány ikonky v GUI verzi, aby byly v logičtějších celcích.

    * Podpora pro MegaVideo.com a MegaPorn.com.

    * Podpora pro Wimp.com.

    * Podpora pro UStream.tv.

      Poznámka pro vývojáře: Podpora AMF je nekompletní, mimo jiné chybí
      komplet všechno kolem AMF3. Podpora bude doplněna, až/pokud bude potřeba.



  v0.31

    * V implementaci televize Joj bylo prohozené datum, takže se stahoval
      špatný soubor.



  v0.30

    * Experimentání podpora pro Joj.sk. Používám hodně pochybný způsob pro 
      získávání adresy videa i jeho stahování, proto se dá očekávat, že to
      nebude fungovat na všechny pořady. Až na takový případ narazíte, budu
      potřebovat jeho URL.

    * Podpora pro Metropol TV (tvpraha11.cz; pokud jsou i jiné adresy, budu
      je potřebovat znát).

    * Podpora pro VideaCesky.cz. Obdobným způsobem jde snadno doplňovat
      další sekundární zdroje (nemají vlastní videa, odkazují na cizí stránky).



  v0.29

    * Další opravy pro kompatibilitu s FreePascalem. GUI verze s ním hned
      tak fungovat nebude, pokud vůbec někdy.

    * Opravena chyba v RTMPDUMP (používá ho např. TV Nova nebo Barrandov),
      která dovolila při jednom spuštění programu stáhnout jen jeden RTMP
      stream.

      Tato chyba také způsobovala, že se dva současně stahované RTMP streamy
      ukládaly do jediného souboru, což tento soubor kompletně znefunkčnilo.
      I to je nyní opraveno a je možné stahovat dva streamy najednou.

    * Zaveden koncept "koncových poskytovatelů", který dovolí lépe řídit
      automatické stahování tak, aby se z jednoho skutečného zdroje stahoval
      v jednu chvíli jen jeden stream (např. iPrima.cz využívá Stream.cz,
      takže je žádoucí, aby v případě, že běží stahování ze Stream.cz,
      downloady z iPrima.cz počkaly).

    * V grafické verzi se nezohledňovalo nastavení "PreferRealMedia" u České
      televize.



  v0.28

    * Podpora pro nové poskytovatele médií:
       - Facebook.com
       - Kukaj.sk
       - LibimSeTi.cz
       - MojeVideo.cz
       - Myubo.sk
       - Videoalbumy.azet.sk
       - Wrzuta.pl

    * Videa z Nova.cz se nyní stahují ve vyšší kvalitě (.mp4).

    * RTMPDUMP_DLL.DLL sestaven s knihovnou PolarSSL místo OpenSSL. Díky tomu
      je odstraněna závislost na OpenSSL knihovnách (CRYPTOEAY32-0.9.8.DLL,
      SSLEAY32-0.9.8.DLL) za cenu prodloužení RTMPDUMP_DLL o nějakých 180 KB.

    * Program lze nyní zkompilovat FreePascalem (http://www.freepascal.org/),
      ověřeno na verzi 2.4.0. Podporována je ale zatím jen command-line verze,
      GUI verzi sice jde přeložit (s využitím projektu Lazarus), ale nebude
      fungovat.



  v0.27

    * Podpora pro nové poskytovatele médií:
       - Bing.com
       - Bofunk.com
       - Break.com.
       - CekniTo.cz (.sk)
       - Clipfish.de
       - CollegeHumor.com
       - CrunchyRoll.com
       - DailyHaha.com
       - DailyMotion.com
       - EbaumsWorld.com
       - ESPN.go.com
       - FileCabi.net
       - Free.Zoznam.sk
       - FreeRide.cz
       - GodTube.com
       - Guba.com
       - LiveLeak.com
       - LiveVideo.com
       - MetaCafe.com
       - MySpace.com Video (http://video.myspace.com)
       - PornHost.com (pozor, porno)
       - PornHub.com (pozor, porno)
       - PornoTube.com (pozor, porno)
       - Raajje.tv
       - RedTube.com (pozor, porno)
       - Rude.com (pozor, porno)
       - RuTube.ru
       - Shufuni.com (pozor, porno)
       - SpankingTube.com (pozor, porno)
       - Stickam.com
       - StreetFire.com
       - Tangle.com
       - TeacherTube.com
       - Tontuyau.com
       - Tube8.com (pozor, porno)
       - VideoClipsDump.com
       - Videu.de
       - Vimeo.com
       - XHamster.com (pozor, porno)
       - XNXX.com (pozor, porno)
       - XTube.com (pozor, porno)
       - XVideoHost.com (pozor, porno)
       - XVideos.com (pozor, porno)
       - YouPorn.com (pozor, porno)
       - Yuvutu.com (pozor, porno)
       - ZkoukniTo.cz (včetně adult sekce)

    * Dokumentace přeložena do angličtiny.

    * Další dočištění zdrojového kódu.

    * Vyjasněno licencování. Program je uvolněn pod GNU GPL3 licencí.

    * RTMPDUMP aktualizován na verzi 2.2d.

    * Knihovna RTMPDUMP_DLL.DLL upravena tak, aby se snáze udržovala a aby
      šlo využívat všechny možnosti, které RTMPDUMP nabízí.

    * Knihovna MSDL_DLL.DLL upravena tak, aby se snáze udržovala a aby
      šlo využívat všechny možnosti, které MSDL nabízí.

    * Podpora pro INI soubor s výchozími nastaveními. Detaily jsou uvedeny
      v dokumentaci.

    * Česká televize se nyní stahuje v nejvyšší kvalitě a podporován je kromě
      Windows Media streamu i stream Real Media. Nastavení je řešeno parametrem
      v INI souboru.

    * Opraveno stahování programu PORT České televize, aby se stahoval i přímo
      program a ne jenom reklama před ním.

    * Parametr -l na příkazové řádce vypíše seznam poskytovatelů.

    * Parametr -v na příkazové řádce zkontroluje dostupnost novější verze.

    * V GUI verzi je nové tlačítko About (F1), které vedle základních informací
      (copyright, homepage programu atd.) zkontroluje dostupnost novější verze
      a zobrazí seznam podporovaných poskytovatelů (podobně jako parametr -l  
      na příkazové řádce).

    * Názvy filmů stahovaných z YouTube mají správnou češtinu.



  v0.26

    * Podpora pro "stránky" na YouTube - seznam videí jednoho tvůrce (např.
      http://www.youtube.com/titanicpiano14). Chovají se obdobně jako 
      playlisty.



  v0.25

    * Podpora pro Snotr.com.



  v0.24

    * Některá YouTube videa nelze stahovat způsobem, který obchází kontrolu
      věku, ale jdou stahovat způsobem původním (z verze 0.22). Kód byl upraven
      tak, aby se v případě selhání nového způsobu stahování zkusil ještě
      způsob starý.

      Příkladem je video http://www.youtube.com/watch?v=REpXf0cmJ64



  v0.23

    * Přepracována práce s playlisty tak, aby výstupy (pro command-line
      verzi) byly přehlednější a snáze se přidávaly další formáty playlistů.

    * Podpora pro YouTube videa označená jako "jen pro dospělé".

    * Parametr -e pro logování nepodařených downloadů.

    * Parametr -s pro vložení odkazů z HTML zdroje. Podporovány jsou lokální
      soubory i stránky na webu. Příklad:

      ytd.exe -s "http://www.zive.cz"
      ytd.exe -s "c:\temp\zive.html"

    * Do grafického rozhraní byly doplněny funkce pro načtení seznamu URL ze
      souboru (jako -i v CLI verzi), načtení podporovaných URL z HTML souboru 
      a načtení podporovaných URL z HTML stránky (obojí jako -s v CLI).

    * V grafickém rozhraní lze nyní uložit seznam nestažených odkazů do
      souboru, který lze později načíst pomocí parametru -i.



  v0.22

    * V grafickém prostředí se zobrazuje nápověda pro jednotlivá tlačítka.

    * Změněna výchozí reakce na existující soubor. Starší verze tento soubor
      bez ptaní přepsaly. Verze 0.22 se uživatele zeptá na požadovanou akci,
      je možné též použít parametry -n (nepřepisovat), -a (přepisovat),
      -r (automaticky přejmenovávat) a -k (ptát se uživatele).

      Grafická verze se ptá pokaždé, když narazí na existující soubor, kromě
      případu, kdy je zaškrtnuta volba "Auto-overwrite" - pak se automaticky
      přepisuje jako v předchozích verzích.

    * Grafická verze se minimalizuje do traye.

    * Pro stahování z YouTube jsou podporovány playlisty (ve formátu
      http://www.youtube.com/view_play_list?p=90D6E7C4DE68E49E) - stáhne
      se vždy celý playlist.



  v0.21

    * Podpora pro Markízu a spol. znefunkčnila YouTube a ostatní providery
      fungující na bázi protokolu HTTP.



  v0.20

    * Česká televize: Podpora pro pořady programu PORT.



  v0.19

    * Některé vytvořené regulární výrazy se z paměti neuvolňovaly, dokud
      aplikace neskončila.

    * YouTube: Video "http://www.youtube.com/watch?v=7INIRLe7x0Y" se ukládalo
      s příponou ".mp4", ale správně je ".flv". Je možné, že jsou i další
      podobné případy, příponu přiřazuji pomocí výčtu a zdaleka nemám 
      kompletní seznam. Když narazíte na video uložené pod špatnou příponou,
      dejte mi prosím vědět.

    * Podpora pro http://www.tvcom.cz.

    * Podpora pro http://www.markiza.sk. Pokud je pořad tvořen několika
      samostatnými soubory, budou staženy všechny.

    * Podpora pro http://www.rozhlas.cz. Pokud je pořad tvořen několika
      samostatnými soubory, budou staženy všechny.



  v0.18

    * Podpora pro změněný design YouTube.



  v0.17

    * Podpora pro protokoly MMS, MMSH, RTSP a jejich varianty tunelované
      přes FTP a HTTP. Podpora je řešena pomocí knihovny MSDL_DLL.DLL,
      která vznikla drobnou úpravou programu MSDL (http://msdl.sf.net/).

    * Podpora pro iVysílání České televize.

    * RTMPDUMP aktualizován na nejčerstvější verzi.



  v0.16

    * Zkráceny výpisy v command-line verzi programu, aby se při stahování
      souborů větších než 100 MB nemnožily řádky s průběhem.

    * Podpora pro videa televize Nova (nova.cz).



  v0.15:
  
    * Restrukturalizován zdrojový kód, aby umožňoval lépe přidávat další
      zdroje médií.

    * Podpora pro stahování streamů přenášených protokolem RTMP. Download
      je řešen pomocí knihovny RTMPDUMP_DLL.DLL, která vznikla drobnou
      úpravou programu RTMPDUMP (http://rtmpdump.mplayerhq.hu). Knihovna
      potřebuje OpenSSL verze 0.9.8, konkrétně knihovny SSLEAY32-0.9.8.DLL
      a CRYPTOEAY32-0.9.8.DLL.

    * Podpora pro Barrandov.tv.



  v0.14:

    * Podpora pro Stream.cz z minulé verze rozhodila ostatní zdroje
      videa, které kvůli tomu nefungovaly. To je nyní opraveno.

    * Upraveno grafické rozhraní (ikonky, tlačítka atd.).

    * Přidána možnost zkompilovat jen CLI nebo jen GUI verzi programu:
      Při spouštění BUILD.BAT můžete použít parametr "CLI" (jen command
      line verze) resp. "GUI" (jen grafická verze) (v obou případech bez
      uvozovek). "CLI" výrazně zmenší výsledný EXE soubor, "GUI" odstraní
      okno konzole. Ve výchozím stavu se kompiluje verze s CLI i GUI
      současně.

    * Knihovna Synapse aktualizována na release 39. Problém se Stream.cz
      (viz upozornění výše) ale stále trvá.

    * Podpora pro download z iPrima.cz (používá Stream.cz).



  v0.13:

    * Přidána podpora pro Stream.cz. Je v tom ale zatím neodhalená chyba,
      viz výše v sekci "podporované weby a formáty."

    * Kromě názvu videa a souboru se nyní zobrazuje i adresa, ze které
      lze video stáhnout "ručně" (např. WGETem).



  v0.12:

    * Nefungovalo stahování filmů, které na YouTube neměly některou
      HD verzi.

    * Kompletně přepracovaná GUI verze. Nyní zobrazuje seznam URL ke
      stažení, umí stahovat víc odkazů najednou atd. 



  v0.11:

    * Experimentální podpora pro vyšší formáty HD videa (720HQ, 1080p).
      Prosím, pokud narazíte na video, kde to nefunguje, pošlete mi
      odkaz.



  v0.10:

    * Kompletně restrukturalizováno, aby se daly snadno přidávat další
      zdroje videa.

    * Změněn tvar všech výstupů, aby byl přehlednější.

    * Podpora pro n-joy.cz.

    * Podpora pro blip.tv.

    * Podpora pro seznam URL v souboru (pomocí parametru -i).

    * Pozor, program nyní potřebuje knihovnu pcre.dll (přiložena).

    * Přidány informace o aplikaci pro GetFileVersionEx. Přidána ikonka.

    * Přidáno jednoduché grafické rozhraní, které se zobrazí, pokud program
      spustíte bez parametrů.



  v0.06:

    * Podpora pro URL ve tvaru http://www.youtube.com/v/(id)



  v0.05:

    * Přeuspořádány zdrojové kódy a buildovací dávka.

    * Podpora pro URL ve tvaru http://www.youtube.com/watch/v/(id)
